import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import com.nttdocomo.io.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;
import com.nttdocomo.system.*;
import com.nttdocomo.opt.ui.*;
import com.nttdocomo.opt.ui.Display2;
import com.nttdocomo.opt.ui.PhoneSystem2;
import com.nttdocomo.opt.ui.PointingDevice;



public final class GBCanvas extends Canvas {

	private static final String versionStr = 
		"    Aniki_de_pon"	+ "\n" +
		"    ver.13+SB.8g"	+ "\n"
							+ "\n" +
		"  is made based on"+ "\n"
							+ "\n" +
		"    uopoy_neuro"	+ "\n" +
		"     Nemulator"	+ "\n" +
		"     nullpoy-sx"	+ "\n" +
		"   Mr.266 & Mr.407"+ "\n"
							+ "\n" +
		" Thanks All Author!"+ "\n"  
	;

	// 萔
	private static final int MODE_NONE = 0;
	private static final int MODE_GAME = 1;
	private static final int MODE_MENU_ROOT = 2;
	private static final int MODE_MENU_SAVE = 3;
	private static final int MODE_MENU_LOAD = 4;
	private static final int MODE_MENU_ROM = 5;
	private static final int MODE_MENU_SETTING = 6;
	private static final int MODE_MENU_SOFTKEY = 7;
	private static final int MODE_PAD_SET = 8;
	private static final int MODE_PAD_SET_EX = 9;
	private static final int MODE_PAD_SET_NOW = 10;
	private static final int MODE_PAD_SET_NOW_EX = 11;
	private static final int MODE_MENU_CHEAT_SET = 12;
	private static final int MODE_FUNC = 13;
	private static final int MODE_MENU_BUTTON_SET = 14;
	private static final int MODE_MENU_AUDIO_SET = 15;
	private static final int MODE_MENU_ROMFILE = 16;
	private static final int MODE_MENU_CONFIRM = 17;
	private static final int MODE_MENU_SP_CACHE = 18;
	private static final int MODE_DIALOG = 19;
	private static final int MODE_ZOOM_SET = 20;
	private static final int MODE_MENU_OTHER_SET = 21;
    private static final int MODE_MENU_ROMINFO = 22;


	/** Z[uf[^. */
	private static final int NUM_STATE = 12;

	/** y[WSDROM. */
	private static final int NUM_SDROM = 12;

	/** őSDROM y[W. */
	private static final int MAX_SDROM_PAGE = 20;

	/** Z[uf[^P̃TCY. */
	//GBC̃TCY傫قɍ킹
	private static final int SIZE_STATE = 106496;

	/** ݒۑp̃TCY. */
	private static final int SIZE_SP_SETTING = 2000;

	/** Save1̖OBGame. */
	private static final int SIZE_STATE_NAME = 32;

	/** ROM̒ */
	private static final int SIZE_ROM_NAME = 32;

	/* Exportp1Block̃TCY */
	private static final int EXPORT_BLOCK_SIZE = 255;

	/* ɏ`[g̐ */
	private static final int NUM_CHEAT = 4;

	String[] SOFTKEY_SOUND_STR  = new String[] {" ~ ", "  "};
	String[] ON_OFF_STR = new String[] { "OFF", "ON" };
	String[] FRAMES_STR = new String[] { "OFF", "LIMIT", "AUTO" };
	String[] FPSDISP_STR = new String[] {"(X^bN)","(tB)","(TCh)",""};
	String[] ZOOM_STR = new String[] { "W", "g", "Ch","t","t["};
	String[] GAME_COLOR = new String[] { "Normal", "Monochrome", "BrightSepia", "DarkSepia", "Red", "Pastel", "Orange", 
		"Yellow", "BrightBlue", "DarkBlue", "Gray", "BrightGreen", "DarkGreen", "Reverse", "܂" };
	String[] POINTER_STR = new String[] { "4", "8" };
	String[] FLIPMODE_STR = new String[] { "ʏ", "E90", "180", "90"};
	String[] SOUND_STR = new String[] { "PRESET", "YAMAHA", "ROHM", "FUETREK", "N505i(PCM)", "SH252i(PCM)", "SA702i(PCM)" };
	public int[] SOUND_RATE_ARRAY = new int[] { 8000, 16000, 32000 };
	String[] SOUND_DELAY_STR = { "{", "1/2", "1/3", "1/4", };
	String[] SOUND_FILTER_STR = new String[] { "NONE", "LOW-PASS", "WEIGHTED" };
	String[] SOFTKEY_BGCOLOR_STR = new String[] { "BLUE", "GRAY", "BLACK", "BLUE+", "GRAY+", "BLACK+" };
	String[] SOFTKEY_STR = new String[] { "pbhݒ", "ȈՃ`[g", "Zbg", "TEh", "`̈", "ROM", "Cӷݒ" };
	String[] DIALOG_STR = new String[] { "Doja", "Ǝ(DojaF)", "Ǝ(ÐF)" };
	String[] HW_CGB_STR = new String[] { "mN", "J[" };
	String[] KEY_STR = new String[] {
		"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "*", 
		"#", "12", "13", "14", "15", "LEFT", "UP", "RIGHT", "DOWN", "SELECT",
		"SOFT_KEY1", "SOFT_KEY2", "23", "IAPPLI", "25", "UPPER_LEFT", "UPPER_RIGHT", "LOWER_RIGHT", "LOWER_LEFT", "PAGE_UP",
		"PAGE_DOWN", "CLEAR", "MAIL", "MEMO", "MENU", "IMODE", "BOOK", "CALENDAR", "VOICE", "MANNER",
		"DRIVE", "GPS", "43", "44", "45", "46", "47", "ROLL_LEFT", "ROLL_RIGHT", "SUB1",
		"SUB2", "SUB3", "MY_SELECT", "54", "55", "CAMERA", "CAMERA_ZOOM_IN", "CAMERA_ZOOM_OUT", "CAMERA_SELECT", "CAMERA_LIGHT",
		"CAMERA_SHOT", "Press Key !", " - "
	};
	
	// CX^Xϐ
	private final GBCore gbcore;
	private Disp disp;

	public static final int[] fb = new int[240 * 216];
	private InputStream inputStream;
	private InputStream romInputStream;
	private Graphics g = getGraphics();
	private String messageStr = "";
	private String info_mbc = "";
	
	private Image allImg = null; //]pS̃C[W
	private Graphics allG = null;
	public Image fb2 = null;
	private Graphics fb2G = null;
	private Image img;
	private Image menuImg = null;
	private Graphics menuG = null;
	private Image msgImg = null;
	private Graphics msgG = null;


	private static final int
		KEY_UP = 0,
		KEY_DOWN = 1,
		KEY_LEFT = 2,
		KEY_RIGHT = 3,
		KEY_A = 4,
		KEY_B = 5,
		KEY_ST = 6,
		KEY_SE = 7,
		KEY_A2 = 8,
		KEY_B2 = 9,
		KEY_ST2 = 10,
		KEY_SE2 = 11,
		KEY_FSU = 12,
		KEY_FSD = 13,
		KEY_ZOOM = 14,
		KEY_SAVE = 15,
		KEY_SS = 16,
		KEY_LS = 17,
		KEY_SHOT = 18,
		KEY_CHEAT = 19,
		SELECT = 0,
		UP = 1,
		DOWN = 2,
		LEFT = 3,
		RIGHT = 4
	;

	private static final int[]
		palette = new int[64],
		pad0 = new int[] {0x04,0x08,0x02,0x01},
		pad1 = new int[] {0x02,0x01,0x08,0x04},
		pad2 = new int[] {0x08,0x04,0x01,0x02},
		pad3 = new int[] {0x01,0x02,0x04,0x08}
		
	;

	/////////////////////////////////
	// ݒ荀
	/////////////////////////////////
	// fps
	private int fps;
	// FrameSkip
	//FSől
	private int FS_max = 30;
	//FSŏl
	private int FS_min = 1;
	//FSl
	private int FS_default = 5;
	private int frameskip;
	private int framecount;
	// fps\邩ǂB
	private boolean fpsOff_;
	// NɑOROMǂݍނB
	private boolean LoadRomFirst;
	//Ōɓǂݍ񂾃
	private int lastRom;
	/* AˁEz[h֘A */
	//{^A
	private int Ren;
	private boolean rapidA;
	private boolean rapidB;
	//{^z[h
	private boolean pressA;
	private boolean pressB;
	private boolean holdA;
	private boolean holdB;
	// j[̓
	private boolean alpha;
	// x(60FPS)
	private long startTime_, lasttime;
	private int sleep_ = 0;
	// 90](0:ʏA1:EA2:180A3:)
	private int flipMode_;
	private int flipModeKey_ = 0;
	// E\tgL[̋@\
	private int rSoftkey_ = 0;
	// j[wiF
	private int menuBGcolor_ = 0;
	// Q[ʐF
	private int gamecolor_ = 0;
	// mFbZ[W
	private int confirmMsg_ = 0;
	// OSDROMԍ
	private int sdNo_;
	// SDt@Cy[W
	private int sdPage_ ;
	// Save{Game
	private String[] saveStr_ = new String[NUM_STATE];
	// SDROMt@CXg
	private String[] subMenuRom = new String[NUM_SDROM];
	//NtO
	private boolean firstExec;

	/* `[g֘A */
	private boolean chtTemp;
	private String chtTxt = "";
	private String chtTxt2 = "";
	private boolean[] chtSw = new boolean[NUM_CHEAT];
	private int[] chtType = new int[NUM_CHEAT];
	private int[] chtVal = new int[NUM_CHEAT];
	private int[] chtAdr = new int[NUM_CHEAT];
	private int[] chtAdr2 = new int[NUM_CHEAT];

	//L[ݒ
	private int keyChange;

	/* j[֘A */
	// j[
	private boolean neuroWay;
	//j[
	private int neuroRight;
	private int neuroLeft;
	private int neuroUp;
	private int neuroDown;
	//j[x
	private int neuroSense;

	/* TEh֘A */
	// TEhʒl
	private int soundVolume_ = 100;
	// TEhobt@
	private int soundBufCount_;
	//TEh`lԍ
	private int[] soundToneNum_ = new int[5];
	//TEhIIt
	private boolean soundEnable_;
	// TEhChIIt
	private boolean[] soundChEnable_ = new boolean[4];
	//XeIIIt
	private boolean[] StereoEnable_ = new boolean[1];
	////PCMTEh֘A////
	//o̓Tv[g
	private int soundSampleRate_;
	//xlύX
	private int soundDelay_;
	//obt@JEg
	private int PCM_SoundBufCount_;
	// Apuo̓tB^[h
	private int soundApuFilter;
	// PCMTEhChIIt
	private boolean[] PCM_soundChannelEnable_ = new boolean[4];
	// Q[ʃY[
	private int zoom_;
	private int svZoom_;
	//FPS\@
	private int fpsDisp_ = 3;
	//g\Aڂ邩ǂ
	private boolean Anti_Alias_ = true;
	// 0:t[(TCY),1:t[(ʒu) Ŏgp
	private int pos_x[] = new int[2];
	private int pos_y[] = new int[2];

	//*** ̑ ***//
	// Q[̃\tgx\L
	private boolean showSoftLabel_ = true;
	// ʂ̔
	private boolean reverseEnable_ = false;
	// Fۂ[V
	private boolean rotateEnable_ = false;
	// Q[̃\tgL[(~b)
	private int wt_on_game_ = 0;
	// ʃtbV̕`҂(~b)
	private int wt_on_refresh_ = 200;
	// QVGAłVGAtHggǂ
	private boolean use_vgafont_ = false;
	// ROMLbV
	private boolean noRomCache_ = false;
	private int compressMode_ = 0;
	private boolean noCompress_ = false;
	// V_CAO (0:IWiA1:V+悤ȐFA2:V+ÐF)
	private int dialogType_ = 1;

	/////////////////////////////////
	// ̑CX^X
	/////////////////////////////////
	// N̓j[\
	private int mode_ = MODE_MENU_ROM;
	// SDROMy[Wԍ
	private int page_ = 1;
	// ROOTj[Iԍ
	private int selectMenuNo_ = 0;
	// SubMenu
	private int selectSubMenuNo_;
	private int svSubMenuLoadNo;
	private int svSubMenuSaveNo;
	private int svSubMenuSettingNo;
	private int svSubMenuKeyConfNo;
	private int svSubMenuPadNo;
	private int svSubMenuCheatNo;
	private int svSubMenuOthersettingNo;
	private int svSubMenuAudioNo;
	private int svSubMenuRomfileNo;
	private int svSubMenuConfirmNo;
	private int svSubMenuSpCacheNo;
	private int svSubMenuOtherNo;
	private int svSubMenuRomInfoNo;

	// SubMenuXg
	private String[] subMenu = new String[1];

	// pbh@\ptO
	private boolean padDisp_ = false;
	//Z[uf[^C|[gꂽ̂ǂ̔
	private boolean importImage;
	//ROMǂނSPۑ邩ǂ
	private boolean SPmode;
	//ǂݍł邩ǂ
	private boolean romload;
	//Xe[gZ[u
	private String saveRomName = "";

	private int[] key = new int[24];
	private int[] pad = new int[4];
	private boolean rYes;
	private boolean displayClear;

	private static final byte[]
		GIF_HEADER = {
			'G','I','F','8','9','a',0x01,0x00,0x01,0x00,0x80 - 0x100,0x00,0x00,0xFF - 0x100,0xFF - 0x100,0xFF - 0x100,0x00,0x00,0x00,0x2C,
			0x00,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x00,0x02,0x02,0x44,0x01,0x00,0x21,0xFE - 0x100
		};

	// Y[
	private int scale = 2; //ׂĂ̕menuGVGAo
	private int mscale = 2; //ʏʂ݂menuG̑傫
	private int zoomMask_ = 0;
	private boolean zoomSizeMode_ = true;
	private boolean pos_reset = false;
	// ޔp
	private int svZoomMask_ = 0;
	private int svPos_x4 = 0;
	private int svPos_y4 = 0;
	//ŋNǂ
	private boolean widedisplay_ = false;
	// 
	private boolean soft1Pressed = false;
	private boolean soft2Pressed = false;
	private boolean keyLongPressed = false;
	// V_CAOp
	// confirm͓Qs邱ƂŎ邵ڂȂ̂ŁA
	// Q񏈗ɌȂӏɂ dialogNotReady tO𗧂ċ̃_CAO\B
	// ̂قAj[ʂȂ_CAO\łȂʂł dialogNotReady 𗧂ĂB
	// ({Iɂ mode_ = MODE_GAME ɓƂɂ͗Ă)
	// svMode ̓_CAOO mode_ ۑpBsvParam lB
	// {Iɂ͎_CAO͑Sʂ̃Av[`ŎȂƂ߂
	public boolean dialogNotReady = true;
	private boolean dialogPressed = false;
	private boolean dialogReleased = false;
	private boolean dialogShowed = false;
	private boolean dialogYes = true;
	private int dialogMode = 0;
	private String dialogMessage = "";
	private int svMode = mode_;
	private int svParam = 0;

	private final Font DEFAULT_FONT;
	private Font MENU_DEFAULT_FONT;
	private int HEIGHT_LINE;
	private int BASE_LINE;
	private int DIALOG_HEIGHT_LINE;
	private int DIALOG_BASE_LINE;

	// [h
	private int MY_KEY_LEFT = Display.KEY_LEFT;
	private int MY_KEY_UP = Display.KEY_UP;
	private int MY_KEY_RIGHT = Display.KEY_RIGHT;
	private int MY_KEY_DOWN = Display.KEY_DOWN;

	// Q[̉E\tgL[̏ꏊύXp
	private int MY_KEY_SOFT1 = Display.KEY_SOFT1;
	private int MY_KEY_SOFT2 = Display.KEY_SOFT2;

	private int MENU_WIDTH;
	private int MENU_HEIGHT;

	public int width;
	public int height;

	public static Vector romhisttemp = new Vector();

	public GBCanvas(){

		fb2 = Image.createImage(240, 240);
		fb2G = fb2.getGraphics();
		try {
			MediaImage mi = MediaManager.getImage("resource:///title.gif");
			mi.use();
			img = mi.getImage();
			} catch (IOException e) {}
		setSoftLabel( Frame.SOFT_KEY_1 , " ߂ " );
		gbcore = new GBCore(this, psgi);
		readSP();
		try {
			if (PointingDevice.isAvailable()) {
				if (neuroSense > 0) {
					PointingDevice.setMode(PointingDevice.MODE_JOYSTICK);
					PointingDevice.setEnabled(true);
				}
			}
		} catch (Exception ex) {
		}

		gbcore.setFrameSkip(frameskip);	//C
		gbcore.setGameColor(gamecolor_);
		setSound();

		width = getWidth();
		height = getHeight();

		int dispSwitch = 0;
		if (width == 480) {
			//VGAc
			dispSwitch = 1;
		} else if (height == 480) {
			//P905ip VGA(邢͂ꑊ)
			dispSwitch = 2;
		} else if (width == 240) {
			//QVGAc
			dispSwitch = 3;
		} else if (height == 240) {
			//P905ip QVGA(邢͂ꑊ)
			dispSwitch = 4;
		} else {
			dispSwitch = 0;
		}
		switch (dispSwitch) {
			case 1 :
				//VGAc - (DrawArea Zx)
				mscale = 1;
				Font.setDefaultFont(Font.getFont(Font.STYLE_PLAIN|Font.SIZE_MEDIUM));
				disp = new Disp480x640(this, gbcore);
  				if (height > 640) {
					zoomMask_ = 2 + 4 + 8 + 16 + 32;
				} else if (height == 640) {
					zoomMask_ = 2 + 4 + 8      + 32;
				} else if (height > 480) {
					zoomMask_ = 2 + 4     + 16 + 32;
				} else {
					zoomMask_ = 2 + 4          + 32;
				}
				break;
			case 2 :
				//P905ip VGA(邢͂ꑊ) - (DrawArea xZ)
				mscale = 1;
				Font.setDefaultFont(Font.getFont(Font.STYLE_PLAIN|Font.SIZE_MEDIUM));
				disp = new Disp640x480(this, gbcore);
				if (width > 640) {
					widedisplay_ = true;
					zoomMask_ = 2 + 4 + 8 + 16 + 32;
				} else if (width == 640) {
					widedisplay_ = true;
					zoomMask_ = 2 + 4 + 8      + 32;
				} else if (width > 480) {
					widedisplay_ = true;
					zoomMask_ = 2 + 4 +     16 + 32;
				} else {
					zoomMask_ = 2 + 4          + 32;
				}
				break;
			case 3 :
				//QVGAc - (DrawArea Zx)
				disp = new Disp240x320(this, gbcore);
				if (height > 320) {
					zoomMask_ = 2 + 4 + 8 + 16 + 32;
				} else if (height == 320) {
					zoomMask_ = 2 + 4 + 8      + 32;
				} else if (height > 240) {
					zoomMask_ = 2 + 4     + 16 + 32;
				} else {
					zoomMask_ = 2 + 4          + 32;
				}
				break;
			case 4 :
				//P905ip QVGA(邢͂ꑊ) - (DrawArea xZ)
				disp = new Disp320x240(this, gbcore);
				if (width > 426) {
					zoomMask_ = 2 + 4 + 8 + 16 + 32;
				} else if (width > 320) {
					widedisplay_ = true;
					zoomMask_ = 2 + 4 + 8 + 16 + 32;
				} else if (width == 320) {
					widedisplay_ = true;
					zoomMask_ = 2 + 4 + 8      + 32;
				} else if (width > 240) {
					widedisplay_ = true;
					zoomMask_ = 2 + 4     + 16 + 32;
				} else {
					zoomMask_ = 2 + 4          + 32;
				}
				break;
			default :
				disp = new Disp240x320(this, gbcore);
				zoomMask_ = 2 + 4           + 32;
		}

		// ]
		allImg = Image.createImage(width, height);

		if (!widedisplay_) {
			int tmp = width;
			width = height;
			height = tmp;
		}
		disp.init();
		MENU_WIDTH = width * mscale;
		MENU_HEIGHT = height * mscale;

		DEFAULT_FONT = Font.getDefaultFont();
		MENU_DEFAULT_FONT = Font.getFont(Font.STYLE_PLAIN|Font.SIZE_MEDIUM);
		// s = tHg + ̗] + ̗]
		HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + (1 + 2 * 2) * scale;
		// x[X = ] + tHgAscent
		BASE_LINE = 3 * scale + MENU_DEFAULT_FONT.getAscent();

		// _CAOp s = tHg + ̗] + ̗]
		DIALOG_HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + 2*scale;
		// _CAOp x[X = ] + tHgAscent
		DIALOG_BASE_LINE = MENU_DEFAULT_FONT.getAscent() + 1*scale;

		// j[p
		if (!use_vgafont_ && mscale == 2) {
			MENU_WIDTH /= mscale;
			MENU_HEIGHT /= mscale;
			scale = 1;
			mscale = 1;
			menuImg = Image.createImage(MENU_WIDTH, MENU_HEIGHT);
			msgImg = Image.createImage(MENU_WIDTH, 16);
			MENU_DEFAULT_FONT = DEFAULT_FONT;
			HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + (1 + 2 * 2);
			BASE_LINE = 3 + MENU_DEFAULT_FONT.getAscent();
			DIALOG_HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + 2;
			DIALOG_BASE_LINE = MENU_DEFAULT_FONT.getAscent() + 1;
		} else {
			try {
				menuImg = Image.createImage(MENU_WIDTH, MENU_HEIGHT);
				msgImg = Image.createImage(MENU_WIDTH, 16 * scale);
			} catch (Exception ex) {
				// XXX Ԃ傫C[WȂ̂ŁAăgC
				MENU_WIDTH /= mscale;
				MENU_HEIGHT /= mscale;
				scale = 1;
				mscale = 1;
				menuImg = Image.createImage(MENU_WIDTH, MENU_HEIGHT);
				msgImg = Image.createImage(MENU_WIDTH, 16);
				MENU_DEFAULT_FONT = DEFAULT_FONT;
				HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + (1 + 2 * 2);
				BASE_LINE = 3 + MENU_DEFAULT_FONT.getAscent();
				DIALOG_HEIGHT_LINE = MENU_DEFAULT_FONT.getHeight() + 2;
				DIALOG_BASE_LINE = MENU_DEFAULT_FONT.getAscent() + 1;
			}
		}
		menuG = menuImg.getGraphics();
		menuG.setFont(MENU_DEFAULT_FONT);
		msgG = msgImg.getGraphics();
		msgG.setFont(MENU_DEFAULT_FONT);

		allG = allImg.getGraphics();
		allG.setFont(DEFAULT_FONT);

		if (isReverse()) {
			MY_KEY_LEFT = Display.KEY_UP;
			MY_KEY_UP = Display.KEY_RIGHT;
			MY_KEY_RIGHT = Display.KEY_DOWN;
			MY_KEY_DOWN = Display.KEY_LEFT;
		}

		setFlipModeKey();
		refreshDisplay();
		setSoftLabel(Frame.SOFT_KEY_2, "̕ҏW" );
		page_ = sdNo_ / NUM_SDROM + 1;
		selectSubMenuNo_ = sdNo_ % NUM_SDROM;
		readSdromNameSP(page_);
		if (LoadRomFirst) {
			loadRom(false);
		}
	}

	public String getSaveFile(final int slot) {
		return "NO" + formatNumber(slot, 2) + ".SAV";
	}

	public void end(int n) {
		framecount += n;
		if (framecount >= 60) {
			long curtime = System.currentTimeMillis();
			fps = 60000 / (int)(curtime - lasttime);
			lasttime = curtime;
			framecount -= 60;
			if (!fpsOff_) {
				if (fps < 10) messageStr = "  " + fps + "FPS : FS = " + frameskip;
				else if (fps < 100) messageStr = " " + fps + "FPS : FS = " + frameskip;
				else if (fps < 1000) messageStr = "" + fps + "FPS : FS = " + frameskip;
			}
		}
		if (neuroSense > 0) usePointerGame();
		// x(60FPS limit)
		if (sleep_ == 1) {
			long tm = startTime_ + (long)(1667 * frameskip / 100);
			do {
				startTime_ = System.currentTimeMillis();
			} while (tm > startTime_); 
			long delay = (startTime_ - tm);
			if (delay > 0 && delay < 50) {
				startTime_ -= delay;
			}
		}
		// x(60FPS auto)
    		if(sleep_ == 2){
			int sample = 1600;// 1666
			long ctime = System.currentTimeMillis();
			if ((ctime - ltime) * 100 < sample * n - 300) {
				if (frameskip > FS_min)
					gbcore.setFrameSkip(--frameskip);
				waits();
				waite((int) (sample * n - (ctime - ltime) * 100) / 100 - 1);
			} else if ((ctime - ltime) * 100 > sample * n + 300) {
				if (frameskip < FS_max)
					gbcore.setFrameSkip(++frameskip);
			} else {
				gbcore.setFrameSkip(frameskip);
			}
			ltime = ctime;
		}

		if (rapidA || rapidB) {
			if (Ren < 65536) Ren++;
			else Ren = 1;
			if (holdA) pressA = true;
			if (holdB) pressB = true;
			if (pressA && rapidA) {
				if (Ren % 2 != 0) {
					gbcore.pad_set(0x10, false);
				} else {
					gbcore.pad_set(0x10, true);
				}
			}
			if (pressB && rapidB) {
				if (Ren % 2 != 0) {
					gbcore.pad_set(0x20, false);
				} else {
					gbcore.pad_set(0x20, true);
				}
			}
		}
		for (int i = 0; i < NUM_CHEAT; i++) {
			if (chtSw[i] && chtAdr2[i] != 0) {
				gbcore.mem_write(chtAdr[i] + (chtAdr2[i] * 0x100),chtVal[i]);
			}
		}
		paint(g);
	}

	private static long ltime = 0;
	private static long start ;
	private static long end ;

	private static void waits(){
		start = System.currentTimeMillis();
	}

	// ۑԂw莞Ԍo߂܂ő҂	
	private static void waite(int waitmsecond){	
		while(((end = System.currentTimeMillis())-start)<waitmsecond){
			if(waitmsecond-(end-start)<=5){
				
			}else if(waitmsecond-(end-start)<=15){
				try{Thread.sleep(1);}catch(Exception ew){}
			}else{
				try{Thread.sleep(10);}catch(Exception ew){}
			}
		};
		start = end;
	}

	private void setMessage(final String s) {
		/*
		* XXX
		*  񗓂ɃbZ[W\郁\bh肷łB
		*  1.j[\
		*   (1)MenuImgdrawString()  paintMenuImage() (messageStrgp)
		*   (2)msgImgdrawString()  paintMenuImage() ({\bh)
		*   (3)msgImgdrawString()  paintMenuImage() (oi[\cbannerStrgp)
		*  2.Q[ʕ\
		*   (1)g܂allGɒ drawString() (`ݒFʏ탂[hcmessageStrgp)
		*   (2)edispNX fps \ƂĎ
		*   (3)edispNX drawString() pĂB(񗓂ɂ͎gĂȂ)
		*/
		messageStr = s;
		msgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		msgG.fillRect(0, 0, MENU_WIDTH, 16 * scale);
		msgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
		msgG.drawString(s, 4 * scale, BASE_LINE);
		paintMenuImage(msgImg, mscale, 0, 224 * scale/mscale, MENU_WIDTH, 16 * scale);
	}

	public void processEvent(int type, int param) {
		long wt = (long)wt_on_game_;
		long ct = 0;
		if (type == Display.KEY_RELEASED_EVENT) {
			for (int kr = 0; kr <12; kr++) {
				if (param == key[kr]) {
					switch (kr) {
						case KEY_UP :
							gbcore.pad_set(pad[kr], false);
							break;
						case KEY_DOWN :
							gbcore.pad_set(pad[kr], false);
							break;
						case KEY_LEFT :
							gbcore.pad_set(pad[kr], false);
							break;
						case KEY_RIGHT :
							gbcore.pad_set(pad[kr], false);
							break;
						case KEY_A :
						case KEY_A2 :
							if (!holdA) {
								gbcore.pad_set(0x10, false);
								pressA = false;
							}
							break;
						case KEY_B :
						case KEY_B2 :
							if (!holdB) {
								gbcore.pad_set(0x20, false);
								pressB = false;
							}
							break;
						case KEY_ST :
						case KEY_ST2 :
							gbcore.pad_set(0x80, false);
							break;
						case KEY_SE :
						case KEY_SE2 :
							gbcore.pad_set(0x40, false);
							break;
						default :
							break;
					}
				}
			}
		}
		if (type == Display.KEY_PRESSED_EVENT) {
			if (param == Display.KEY_IAPP) {
				MApplication ma = (MApplication)(IApplication.getCurrentApp());
				IApplication ia = (IApplication.getCurrentApp());
				if (ia.getLaunchType() == IApplication.LAUNCHED_AS_CONCIERGE) {
					while (getKeypadState() > 0);
					ma.deactivate();
				}
			}
			switch (mode_) {
				case MODE_GAME :
					switch (param) {
						case Display.KEY_SOFT1 :
							while (getKeypadState() != 0){
								ct = System.currentTimeMillis();
								if (wt < 200) {
									soft1Pressed = true;
								}
								while (System.currentTimeMillis() - ct < wt) {
									if (getKeypadState() == 0) break;
									try {
										Thread.sleep(10L);
									} catch (Exception ex) {}
								}
								wt = 180;
							}
						case Display.KEY_SOFT2 :
							if (rSoftkey_ == 6) {
								selectGamekey(param);
							}
							while (getKeypadState() != 0){
								ct = System.currentTimeMillis();
								if (wt < 200) {
									soft2Pressed = true;
								}
								while (System.currentTimeMillis() - ct < wt) {
									if (getKeypadState() == 0) break;
									try {
										Thread.sleep(10L);
									} catch (Exception ex) {}
								}
								wt = 180;
							}
							break;
						default :
							selectGamekey(param);
							break;
					}
					break;
				case MODE_PAD_SET_NOW :
				case MODE_PAD_SET_NOW_EX :
					break;

				case MODE_DIALOG :
					switch (param) {
						case Display.KEY_SELECT :
							dialogPressed = true;
							repaint();
							break;
						case Display.KEY_UP :
						case Display.KEY_DOWN :
						case Display.KEY_RIGHT :
						case Display.KEY_LEFT :
							dialogYes = !dialogYes;
							repaint();
							break;
					}
					break;
				default :
					svParam = param;
					keyPressMenu(param);
					break;
			}
		} else if (type == Display.KEY_RELEASED_EVENT) {
			switch (mode_) {
				case MODE_GAME :
					if (soft1Pressed && param == Display.KEY_SOFT1) {
						soft1Pressed = false;
						gbcore.emu_running = false;
						mode_ = MODE_MENU_ROOT;
						setSoftLabel( Frame.SOFT_KEY_1 , " ߂ " );
						setSoftLabel( Frame.SOFT_KEY_2 , " I " );
						messageStr = "";
						refreshDisplay();
						repaint();
						break;
					} else if (soft2Pressed) {
						soft2Pressed = false;
						if (param == Display.KEY_SOFT2 && rSoftkey_ == 0) {
							gbcore.emu_running = false;
							padDisp_ = true;
							refreshDisplay();
							messageStr = "";
							setSoftLabel( Frame.SOFT_KEY_2 , " ߂ " );
							selectSubMenuNo_ = svSubMenuPadNo;
							mode_ = MODE_MENU_BUTTON_SET;
							repaint();
						} else if (param == Display.KEY_SOFT2 && rSoftkey_ == 1) {
							gbcore.emu_running = false;
							padDisp_ = true;
							refreshDisplay();
							messageStr = "";
							setSoftLabel( Frame.SOFT_KEY_2 , " ߂ " );
							selectSubMenuNo_ = svSubMenuCheatNo;
							mode_ = MODE_MENU_CHEAT_SET;
							repaint();
						} else if (param == Display.KEY_SOFT2 && rSoftkey_ == 2) {
							gbcore.emu_running = false;
							rYes = confirm("Zbg܂H");
							if (rYes) {
								if (romload) {
									gbcore.emu_reset();
									resumeGame();
								}
							} else {
								resumeGame();
							}
						} else if (param == Display.KEY_SOFT2 && rSoftkey_ == 3) {
							soundEnable_ = !soundEnable_;
							psgi.setSoundEnable(soundEnable_);
							gbcore.pcm.setSoundEnable(soundEnable_);
							setRightSoftkeyLabel();
							writeSP();
							break;
						} else if (param == Display.KEY_SOFT2 && rSoftkey_ == 4) {
							gbcore.emu_running = false;
							padDisp_ = true;
							setSoftLabel(Frame.SOFT_KEY_1, " ߂ ");
							setSoftLabel(Frame.SOFT_KEY_2, ZOOM_STR[(flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_]);
							zoomSizeMode_ = true;
							mode_ = MODE_ZOOM_SET;
							if ((!isReverse() && flipMode_ == 2) || (isReverse() && flipMode_ == 1)) {
								//cʁA180
								//Po[X@E90@flipModeKey_ = 2@flipMode_ = 1
								//FE|180@flipModeKey_3.flipMode_2@flipModeKey_1.flipMode_2
								MY_KEY_LEFT = Display.KEY_RIGHT;
								MY_KEY_UP = Display.KEY_DOWN;
								MY_KEY_RIGHT = Display.KEY_LEFT;
								MY_KEY_DOWN = Display.KEY_UP;
							} else if (flipMode_ == 3 && !isReverse() || (isReverse() && flipMode_ == 2)) {
								//cʁA90
								//FE|@90@flipModeKey_0.flipMode_3@flipModeKey_2.flipMode_3
								//Po[X@180@flipModeKey_ = 3@flipMode_ = 2
								MY_KEY_LEFT = Display.KEY_DOWN;
								MY_KEY_UP = Display.KEY_LEFT;
								MY_KEY_RIGHT = Display.KEY_UP;
								MY_KEY_DOWN = Display.KEY_RIGHT;
							} else if (flipMode_ == 1 || (isReverse() && flipMode_ != 3)) {
								//cʁAE90
								//FE|@E90@flipModeKey_2.flipMode_1@flipModeKey_0.flipMode_1
								//Po[X]
								MY_KEY_LEFT = Display.KEY_UP;
								MY_KEY_UP = Display.KEY_RIGHT;
								MY_KEY_RIGHT = Display.KEY_DOWN;
								MY_KEY_DOWN = Display.KEY_LEFT;
							} else {
								//cʁA]
								//FE]Ȃ
								//Po[X@90@flipModeKey_ = 0@flipMode_ = 3
								MY_KEY_LEFT = Display.KEY_LEFT;
								MY_KEY_UP = Display.KEY_UP;
								MY_KEY_RIGHT = Display.KEY_RIGHT;
								MY_KEY_DOWN = Display.KEY_DOWN;
							}
							repaint();
						} else if (param == Display.KEY_SOFT2 && rSoftkey_ == 5) {
							gbcore.emu_running = false;
							padDisp_ = true;
							refreshDisplay();
							messageStr = "";
							info_mbc_type();
							setSoftLabel( Frame.SOFT_KEY_2 , " ߂ " );
							selectSubMenuNo_ = svSubMenuRomInfoNo;
							mode_ = MODE_MENU_ROMINFO;
							repaint();
						}
					} else {
						selectGamekey2(param);
					}
					break;
				case MODE_PAD_SET_NOW :
				case MODE_PAD_SET_NOW_EX :
					dialogNotReady = true;//߂ǂȂ̂ŁA_CAO̓ftH
					if (param == Display.KEY_SOFT1) {
						setSoftLabel( Frame.SOFT_KEY_1 , " ߂ " );
						key[keyChange] = 63;
						if (confirm("L[ݒNA܂H")) {
							for (int clearKey = 0; clearKey < 24; clearKey++) {
								key[clearKey] = 63;
							}
						}
					} else {
						key[keyChange] = param;
						setSoftLabel( Frame.SOFT_KEY_1 , " ߂ " );
					}
					repaint();
					writeSP();
					if ( mode_ == MODE_PAD_SET_NOW ){
						mode_ = MODE_PAD_SET;
					}else if ( mode_ == MODE_PAD_SET_NOW_EX ){
						mode_ = MODE_PAD_SET_EX;
					}
					break;
				case MODE_DIALOG :
					if (param == Display.KEY_SELECT) {
						dialogPressed = false;
						dialogReleased = true;
						dialogMessage = "";
						mode_ = svMode;
						repaint();
						if (dialogMode == Dialog.DIALOG_YESNO) {
							keyPressMenu(svParam);
							keyReleaseMenu(svParam);
						} else {
							dialogReleased = false;
							dialogShowed = false;
							messageStr = "";
							refreshDisplay();
							repaint();
						}
					}
                    			break;
				default :
					keyReleaseMenu(param);
					break;
			}
		} else if (type == Display2.DISPLAY_STYLE_CHANGED_EVENT ||
			type == Display.RESUME_VM_EVENT) {
			//ȓd͐ݒ(ƂTXyh)ĂƁAĊJςĂ
			//DISPLAY_STYLE_CHANGED_EVENT΂Ȃ̂ŁARESUME_VM_EVENTE
			setFlipModeKey();
			refreshDisplay();
			repaint();
		}

	}

	private void setflipPad() {
		switch (rotateEnable_?flipMode_:flipModeKey_) { 
			case 1 : 
				pad = pad1; 
				break; 
			case 2 : 
				pad = pad2; 
				break; 
			case 3 : 
				pad = pad3; 
				break; 
			default : 
				pad = pad0; 
				break; 
		} 
	} 

	/*
	* {Iɂ͒ɕKvȏ keyPressMenu() 
	*  - ɌJԂ     keyPressMenu()Ń[v
	*  - _@ɂP񂾂 keyPressMenu()ŃtO𗧂ĂāAkeyRelaseMenu()ŏ
	*/
	private void keyPressMenu(final int param) {
		long wt = 700;
		long ct = 0;
		if (param == Display.KEY_SOFT2) {
			if (padDisp_ && mode_== MODE_ZOOM_SET) {
				while (getKeypadState() != 0){
					ct = System.currentTimeMillis();
					if (wt < 200) {
						pos_reset = true;
					}
					while (System.currentTimeMillis() - ct < wt) {
						if (getKeypadState() == 0) break;
						try {
							Thread.sleep(10L);
						} catch (Exception ex) {}
					}
					wt = 180;
				}
			}
		} else if (param == Display.KEY_SELECT) {
			while (getKeypadState() != 0){
				ct = System.currentTimeMillis();
				if (wt < 200) {
					keyLongPressed = true;
				}
				while (System.currentTimeMillis() - ct < wt) {
					if (getKeypadState() == 0) break;
					try {
						Thread.sleep(10L);
					} catch (Exception ex) {}
				}
				wt = 180;
			}

		} else if (param == MY_KEY_UP) {
			while (getKeypadState() != 0){
				ct = System.currentTimeMillis();
				if (mode_ == MODE_MENU_ROOT) {
					selectMenuNo_ =
						incNo(selectMenuNo_, -1, subMenu.length);
				} else if (mode_ == MODE_ZOOM_SET) {
					if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) {
						int zoomA = zoomSizeMode_ ? 0 : 1;
						int sc = (2 / (scale / mscale));
						if (wt < 200) pos_y[zoomA] -= 32 / sc;
						else pos_y[zoomA] -= 8 / sc;
						if (pos_y[zoomA] < 0) pos_y[zoomA] = 0;
						switch (zoomA) {
							case 0 :
								if ((pos_y[0] + pos_y[1]) > height) pos_y[0] = ((height - pos_y[1]) > 0) ? (height - pos_y[1]) : 0;
								break;
							case 1 :
								if ((pos_y[1] + pos_y[0]) > height) pos_y[1] = ((height - pos_y[0]) > 0) ? (height - pos_y[0]) : 0;
								break;
						}
						writeSP();
						refreshDisplay();
						repaint();
					}
				} else {
					selectSubMenuNo_ =
						incNo(selectSubMenuNo_, -1, subMenu.length);
				}
				if (mode_ != MODE_ZOOM_SET) repaint();
				while (System.currentTimeMillis() - ct < wt) {
					if (getKeypadState() == 0) break;
					try {
						Thread.sleep(10L);
					} catch (Exception ex) {}
				}
				wt = 180;
			}
		} else if (param == MY_KEY_DOWN) {
			while (getKeypadState() != 0){
				ct = System.currentTimeMillis();
				if (mode_ == MODE_MENU_ROOT) {
					selectMenuNo_ =
						incNo(selectMenuNo_, +1, subMenu.length);
				} else if (mode_ == MODE_ZOOM_SET) {
					if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) {
						int zoomA = zoomSizeMode_ ? 0 : 1;
						int sc = (2 / (scale / mscale));
						if (wt < 200) pos_y[zoomA] += 32 / sc;
						else pos_y[zoomA] += 8 / sc;
						switch (zoomA) {
							case 0 :
								if ((pos_y[0] + pos_y[1]) > height) pos_y[0] = ((height - pos_y[1]) > 0) ? (height - pos_y[1]) : 0;
								break;
							case 1 :
								if ((pos_y[1] + pos_y[0]) > height) pos_y[1] = ((height - pos_y[0]) > 0) ? (height - pos_y[0]) : 0;
								break;
						}
						writeSP();
						refreshDisplay();
						repaint();
					}
				} else {
					selectSubMenuNo_ =
						incNo(selectSubMenuNo_, +1, subMenu.length);
				}
				if (mode_ != MODE_ZOOM_SET) repaint();
				while (System.currentTimeMillis() - ct < wt) {
					if (getKeypadState() == 0) break;
					try {
						Thread.sleep(10L);
					} catch (Exception ex) {}
				}
				wt = 180;
			}
		} else if (param == MY_KEY_RIGHT) {
			while (getKeypadState() != 0){
				ct = System.currentTimeMillis();
				switch (mode_) {
					case MODE_MENU_ROM :
						if (page_ < sdPage_ ){
						page_++;
						} else {
							page_ = 1;
						}
						readSdromNameSP(page_);
						break;
					case MODE_MENU_SETTING :
						menuSetting(RIGHT);
						break;
					case MODE_MENU_BUTTON_SET :
						menuPadFunc(RIGHT);
						break;
					case MODE_MENU_CONFIRM :
						if (selectSubMenuNo_ != 5) selectMenuConfirm();
						break;
					case MODE_FUNC :
						menuFunc(RIGHT);
						break;
					case MODE_MENU_CHEAT_SET :
						menuCheat(RIGHT);
						break;
					case MODE_MENU_AUDIO_SET:
						selectAudioSetting(RIGHT);
						int bank = selectSubMenuNo_ - 6;
						if (selectSubMenuNo_ > 5 && selectSubMenuNo_ < 11){
							if (wt < 200) {
								soundToneNum_[bank] = (soundToneNum_[bank] + 10) / 10 * 10;
							} else {
								soundToneNum_[bank]++;
							}
							if(soundToneNum_[bank] > 127) soundToneNum_[bank] = 0;
						}
						break;
					case MODE_MENU_OTHER_SET :
						selectMenuOtherSetting(RIGHT);
						if (selectSubMenuNo_ == 1) {
							if (wt < 200) wt_on_game_ += 1000;
							else wt_on_game_ += 100;
							if (wt_on_game_ > 10000) wt_on_game_ = 10000;
						} else if (selectSubMenuNo_ == 2) {
							if (wt < 200) wt_on_refresh_ += 1000;
							else wt_on_refresh_ += 100;
							if (wt_on_refresh_ > 10000) wt_on_refresh_ = 10000;
						}
						break;
					case MODE_MENU_ROMINFO :
						menuRomInfo();
						break;
					case MODE_ZOOM_SET :
						if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) {
							int zoomA = zoomSizeMode_ ? 0 : 1;
							int sc = (2 / (scale / mscale));
							if (wt < 200) pos_x[zoomA] += 32 / sc;
							else pos_x[zoomA] += 8 / sc;
							switch (zoomA) {
								case 0 :
									if ((pos_x[0] + pos_x[1]) > width) pos_x[0] = ((width - pos_x[1]) > 0) ? (width - pos_x[1]) : 0;
									break;
								case 1 :
									if ((pos_x[1] + pos_x[0]) > width) pos_x[1] = ((width - pos_x[0]) > 0) ? (width - pos_x[0]) : 0;
									break;
							}
							writeSP();
							refreshDisplay();
							repaint();
						}
						break;
				}
				if (mode_ != MODE_ZOOM_SET) repaint();
				while (System.currentTimeMillis() - ct < wt) {
					if (getKeypadState() == 0) break;
					try {
						Thread.sleep(10L);
					} catch (Exception ex) {}
				}
				wt = 180;
			}
		} else if (param == MY_KEY_LEFT) {
			while (getKeypadState() != 0){
				ct = System.currentTimeMillis();
				switch (mode_) {
					case MODE_MENU_ROM :
						if (page_ > 1 ){
							page_--;
						} else {
							page_ = sdPage_;
						}
						readSdromNameSP(page_);
						break;
					case MODE_MENU_SETTING :
						menuSetting(LEFT);
						break;
					case MODE_MENU_BUTTON_SET :
						menuPadFunc(LEFT);
						break;
					case MODE_MENU_CONFIRM :
						if (selectSubMenuNo_ != 5) selectMenuConfirm();
						break;
					case MODE_FUNC :
						menuFunc(LEFT);
						break;
					case MODE_MENU_CHEAT_SET :
						menuCheat(LEFT);
						break;
					case MODE_MENU_AUDIO_SET:
						selectAudioSetting(LEFT);
						int bank = selectSubMenuNo_ - 6;
						if (selectSubMenuNo_ > 5 && selectSubMenuNo_ < 11){
							if (wt < 200) {
								soundToneNum_[bank] = (soundToneNum_[bank] - 1) / 10 * 10;
							} else {
								soundToneNum_[bank]--;
							}
							if(soundToneNum_[bank] < 0) soundToneNum_[bank] = 127;
						}
						break;
					case MODE_MENU_OTHER_SET :
						selectMenuOtherSetting(LEFT);
						if (selectSubMenuNo_ == 1) {
							if (wt < 200) wt_on_game_ -= 1000;
							else wt_on_game_ -= 100;
							if (wt_on_game_ < 0) wt_on_game_ = 0;
						} else if (selectSubMenuNo_ == 2) {
							if (wt < 200) wt_on_refresh_ -= 1000;
							else wt_on_refresh_ -= 100;
							if (wt_on_refresh_ < 0) wt_on_refresh_ = 0;
						}
						break;
					case MODE_MENU_ROMINFO :
						menuRomInfo();
						break;
					case MODE_ZOOM_SET :
						if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) {
							int zoomA = zoomSizeMode_ ? 0 : 1;
							int sc = (2 / (scale / mscale));
							if (wt < 200) pos_x[zoomA] -= 32 / sc;
							else pos_x[zoomA] -= 8 / sc;
							if (pos_x[zoomA] < 0) pos_x[zoomA] = 0;
							switch (zoomA) {
								case 0 :
									if ((pos_x[0] + pos_x[1]) > width) pos_x[0] = ((width - pos_x[1]) > 0) ? (width - pos_x[1]) : 0;
									break;
								case 1 :
									if ((pos_x[1] + pos_x[0]) > width) pos_x[1] = ((width - pos_x[0]) > 0) ? (width - pos_x[0]) : 0;
									break;
							}
							writeSP();
							refreshDisplay();
							repaint();
						}
						break;

				}
				if (mode_ != MODE_ZOOM_SET) repaint();
				while (System.currentTimeMillis() - ct < wt) {
					if (getKeypadState() == 0) break;
					try {
						Thread.sleep(10L);
					} catch (Exception ex) {}
				}
				wt = 180;
			}
		}
	}

	/*
	* {Iɂ͍ĕ`(repaint) keyReleaseMenu() 
	*/
	private void keyReleaseMenu(final int param) {
		String tmp;
		boolean done = false;
		if (padDisp_){
			if (param == Display.KEY_SOFT1) {
				switch (mode_) {
					case MODE_ZOOM_SET :
						mode_ = MODE_GAME;
						setSoftLabel(Frame.SOFT_KEY_1, "MENU");
						setRightSoftkeyLabel();
						padDisp_ = false;
						resumeGame();
						writeSP();
						done = true;
						break;
				}
			} else if (param == Display.KEY_SOFT2) {
				switch (mode_) {
					case MODE_MENU_BUTTON_SET :
					case MODE_MENU_CHEAT_SET :
					case MODE_MENU_ROMINFO :
						if (rSoftkey_ == 0) {
							svSubMenuPadNo = selectSubMenuNo_;
						} else if (rSoftkey_ == 1) {
							svSubMenuCheatNo = selectSubMenuNo_;
						} else if (rSoftkey_ == 5) {
							svSubMenuRomInfoNo = selectSubMenuNo_;
						}
						padDisp_ = false;
						resumeGame();
						mode_ = MODE_GAME;
						done = true;
						break;
					case MODE_ZOOM_SET :
						if (pos_reset) {
							pos_reset = false;
							if (confirm("ʒuZbg܂H")) {
								pos_x[0] = 100;
								pos_y[0] = 100;
								pos_x[1] = 0;
								pos_y[1] = 0;
								svPos_x4 = 0;
								svPos_y4 = 0;
								writeSP();
							}
						} else {
							switch (flipModeKey_) {
								case 1 :
								case 3 :
									if (++svZoom_ > 4) svZoom_ = 0;
									if (((2 << svZoom_) & zoomMask_) == 0) {
										if (++svZoom_ > 4) svZoom_ = 0;
										if (((2 << svZoom_) & zoomMask_) == 0) {
											if (++svZoom_ > 4) svZoom_ = 0;
											if (((2 << svZoom_) & zoomMask_) == 0) {
												if (++svZoom_ > 4) svZoom_ = 0;
												if (((2 << svZoom_) & zoomMask_) == 0) {
													if (++svZoom_ > 4) svZoom_ = 0;
												}
											}
										}
									}
									break;
								case 0 :
								case 2 :
									if (++zoom_ > 4) zoom_ = 0;
									if (((2 << zoom_) & zoomMask_) == 0) {
										if (++zoom_ > 4) zoom_ = 0;
										if (((2 << zoom_) & zoomMask_) == 0) {
											if (++zoom_ > 4) zoom_ = 0;
											if (((2 << zoom_) & zoomMask_) == 0) {
												if (++zoom_ > 4) zoom_ = 0;
												if (((2 << zoom_) & zoomMask_) == 0) {
													if (++zoom_ > 4) zoom_ = 0;
												}
											}
										}
									}
									break;
							}
							int sc = (2 / (scale / mscale));
							switch ((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) {
								case 4 :
									if (pos_x[0] + pos_x[1] > width) {
										pos_x[1] = 0;
										if (pos_x[0] > width) pos_x[0] = width;
									}
									if (pos_y[0] + pos_y[1] > height) {
										pos_y[1] = 0;
										if (pos_y[0] > height) pos_y[0] = height;
									}
									break;
							}
							setSoftLabel(Frame.SOFT_KEY_2, ZOOM_STR[(flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_]);
							writeSP();
						}
						done = true;
						break;
				}
			}
		}
		if (done) {
			refreshDisplay();
			repaint();
			return;
		}

		switch (param) {
			case Display.KEY_SOFT1 :
				switch (mode_) {
					case MODE_MENU_ROOT :
						messageStr = "";
						resumeGame();
						refreshDisplay();
						break;
					case MODE_MENU_SOFTKEY :
						selectSubMenuNo_ = 6;
						mode_ = MODE_MENU_SETTING;
						break;
					case MODE_MENU_AUDIO_SET :
						setSound();
						svSubMenuAudioNo = selectSubMenuNo_;
						selectSubMenuNo_ = 8;
						mode_ = MODE_MENU_SETTING;
						break;
					case MODE_MENU_ROMFILE :
						svSubMenuRomfileNo = selectSubMenuNo_;
						selectSubMenuNo_ = 9;
						mode_ = MODE_MENU_SETTING;
						break;
					case MODE_MENU_CONFIRM :
						svSubMenuConfirmNo = selectSubMenuNo_;
						selectSubMenuNo_ = 10;
						mode_ = MODE_MENU_SETTING;
						break;
					case MODE_MENU_OTHER_SET :
						svSubMenuOtherNo = selectSubMenuNo_;
						selectSubMenuNo_ = 11;
						mode_ = MODE_MENU_SETTING;
						break;
					case MODE_MENU_ROM :
						if (SPmode) {
							mode_ = MODE_MENU_SP_CACHE;
							selectSubMenuNo_ = 0;
							SPmode = false;
						} else{
							mode_ = MODE_MENU_ROOT;
						}
						messageStr = "";
						break;
					case MODE_MENU_LOAD :
						svSubMenuLoadNo = selectSubMenuNo_;
						mode_ = MODE_MENU_ROOT;
						break;
					case MODE_MENU_SAVE :
						svSubMenuSaveNo = selectSubMenuNo_;
						mode_ = MODE_MENU_ROOT;
						break;
					case MODE_MENU_SETTING :
						svSubMenuSettingNo = selectSubMenuNo_;
						mode_ = MODE_MENU_ROOT;
						break;
					case MODE_PAD_SET :
					case MODE_PAD_SET_EX :
						svSubMenuKeyConfNo = selectSubMenuNo_;
						mode_ = MODE_MENU_ROOT;
						break;
					case MODE_MENU_BUTTON_SET:
						svSubMenuPadNo = selectSubMenuNo_;
						mode_ = MODE_MENU_ROOT;
						break;
					case MODE_MENU_CHEAT_SET:
						svSubMenuCheatNo = selectSubMenuNo_;
						mode_ = MODE_MENU_ROOT;
						break;
					case MODE_FUNC:
						svSubMenuOthersettingNo = selectSubMenuNo_;
						mode_ = MODE_MENU_ROOT;
						break;
					case MODE_MENU_SP_CACHE:
						svSubMenuSpCacheNo = selectSubMenuNo_;
						mode_ = MODE_MENU_ROOT;
						break;
					case MODE_ZOOM_SET :
						if (padDisp_) {
							mode_ = MODE_GAME;
							setSoftLabel(Frame.SOFT_KEY_1, "MENU");
							setRightSoftkeyLabel();
							padDisp_ = false;
							resumeGame();
							writeSP();
							refreshDisplay();
						}
						break;
					default :
						messageStr = "";
						mode_ = MODE_MENU_ROOT;
				}
				if (mode_ == MODE_MENU_ROOT) {
					setSoftLabel(Frame.SOFT_KEY_2, " I " );
				}else if (mode_ == MODE_MENU_SETTING) {
					setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
				}
				repaint();
				writeSP();
				break;

			case Display.KEY_SOFT2 :
				switch (mode_) {
					case MODE_MENU_ROOT :
						boolean rYes = true;
						if ((confirmMsg_ & 4) != 0) rYes = confirm("I܂H");
						if (rYes) {
							if (romload) {
								gbcore.saveRamToSD();
								IApplication.getCurrentApp().terminate();
							} else {
								IApplication.getCurrentApp().terminate();
							}
						}
						break;
					case MODE_MENU_ROM :
						imeOn(subMenuRom[selectSubMenuNo_].trim(), TextBox.DISPLAY_ANY, TextBox.KANA);
						break;
					case MODE_MENU_LOAD :
						exportGIF(selectSubMenuNo_);
						break;
					case MODE_MENU_SAVE :
						importGIF(selectSubMenuNo_);
						break;
					case MODE_MENU_SETTING :
						if (++menuBGcolor_ > 5) menuBGcolor_ = 0;
                    	setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
                        writeSP();
                       	repaint();
                       	break;
					case MODE_PAD_SET :
						setSoftLabel( Frame.SOFT_KEY_2 , " ʏ " );
						selectSubMenuNo_ = (selectSubMenuNo_ >= 8) ? selectSubMenuNo_ = 7 : selectSubMenuNo_;
						mode_ = MODE_PAD_SET_EX;
						repaint();
						break;
					case MODE_PAD_SET_EX :
						setSoftLabel( Frame.SOFT_KEY_2 , "  " );
						mode_ = MODE_PAD_SET;
						repaint();
						break;
					case MODE_MENU_AUDIO_SET :
						initSoundSettings();
						repaint();
						break;
					default :
						break;
				}
				break;

			case Display.KEY_1 :
			case Display.KEY_2 :
			case Display.KEY_3 :
			case Display.KEY_4 :
			case Display.KEY_5 :
			case Display.KEY_6 :
			case Display.KEY_7 :
			case Display.KEY_8 :
			case Display.KEY_9 :
			case Display.KEY_0 :
			case Display.KEY_ASTERISK :
			case Display.KEY_POUND :
				int pno;
				switch (param) {
					case Display.KEY_0 :
						pno = 10;
						break;
					case Display.KEY_ASTERISK :
					case Display.KEY_POUND :
						pno = param + 1;
						break;
					default :
						pno = param;
				}
				if (mode_ == MODE_MENU_ROOT) {
					if (pno > subMenu.length) {
						break;
					}
					selectMenuNo_ = pno - 1;
				} else {
					if (pno > subMenu.length) {
						break;
					}
					selectSubMenuNo_ = pno - 1;
				}
				paint(g); //KvȁH
				// KEY_SELECT̓BbreakȂB
			case Display.KEY_SELECT :
				switch (mode_) {
					case MODE_MENU_ROOT :
						selectMenuRoot();
						break;
					case MODE_MENU_ROM :
						if (!SPmode) {
							loadRom(true);
						} else {
							selectSpcache();
						}
						break;
					case MODE_MENU_LOAD :
						if (romload) {
							if (saveStr_[selectSubMenuNo_].compareTo("0") > 0){
								boolean rYes = true;
								if ((confirmMsg_ & 1) != 0) rYes = confirm(saveStr_[selectSubMenuNo_] + "\n" + " [h܂H");
								if (rYes) {
									messageStr = "[hDDDb҂";
									setMessage(messageStr);
									loadState(selectSubMenuNo_);
									svSubMenuLoadNo = selectSubMenuNo_;
									setSoftLabel( Frame.SOFT_KEY_2 , "" );
									messageStr = "";
									resumeGame();
								}
							}
						} else {
							alert("ROMǍłɂĂ!!");
						}
						break;
					case MODE_MENU_SAVE :
						if (romload) {
							boolean rYes = true;
							if ((confirmMsg_ & 2) != 0) rYes = confirm(selectSubMenuNo_ + 1 + "ԂɃZ[u܂H");
							if (rYes) {
								writeSaveDate();
								setMessage(" Z[uDDDb҂");
								saveState(selectSubMenuNo_);
								svSubMenuSaveNo = selectSubMenuNo_;
								svSubMenuLoadNo = selectSubMenuNo_;
								setSoftLabel( Frame.SOFT_KEY_2 , "" );
								resumeGame();
							}
						} else {
							alert("ROMǍłɂĂ!!");
						}
						break;
					case MODE_MENU_SETTING :
						menuSetting(SELECT);
						break;
					case MODE_MENU_SOFTKEY :
						selectMenuSoftkey();
						break;
					case MODE_PAD_SET :
						padSetting(selectSubMenuNo_);
						mode_ = MODE_PAD_SET_NOW;
						break;
					case MODE_PAD_SET_EX :
						padSetting(selectSubMenuNo_ + 12);
						mode_ = MODE_PAD_SET_NOW_EX;
						break;
					case MODE_MENU_BUTTON_SET :
						menuPadFunc(SELECT);
						break;
					case MODE_FUNC :
						menuFunc(SELECT);
						break;
					case MODE_MENU_CHEAT_SET :
						menuCheat(SELECT);
						break;
					case MODE_MENU_AUDIO_SET :
						selectAudioSetting(SELECT);
						break;
					case MODE_MENU_ROMFILE :
						menuRomFile();
						break;
					case MODE_MENU_CONFIRM :
						selectMenuConfirm();
						break;
					case MODE_MENU_SP_CACHE :
						selectMenuSpcache();
						break;
					case MODE_MENU_OTHER_SET :
						selectMenuOtherSetting(SELECT);
						break;
					case MODE_MENU_ROMINFO :
						menuRomInfo();
						break;
					case MODE_ZOOM_SET :
						if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) zoomSizeMode_ = !zoomSizeMode_;
						repaint();
						break;
				}
				if (mode_ == MODE_PAD_SET_NOW ||mode_ == MODE_PAD_SET_NOW_EX) {
					setSoftLabel( Frame.SOFT_KEY_1 , "RESET" );
				}
				keyLongPressed = false;
				break;
			default :
				if (param == MY_KEY_UP || param == MY_KEY_DOWN ||
					param == MY_KEY_RIGHT || param == MY_KEY_LEFT) {
					if (mode_ != MODE_ZOOM_SET) repaint();
				}
				break;
		}
	}

	//͎󂯎
	public void processIMEEvent(int type, String text) {
		if (type==IME_COMMITTED) {
			switch (mode_) {
				case MODE_MENU_ROM :
					text = formatSpace(text, 32);
					subMenuRom[selectSubMenuNo_] = text;
					writeSdromNameSP((page_ - 1) * NUM_SDROM + selectSubMenuNo_, text);
					repaint();
					break;
				case MODE_MENU_ROMFILE :
				// ROM̃C|[g
					if (selectSubMenuNo_ == 3 && !text.equals("")) {
						messageStr = "ROM̃C|[g";
						repaint();
						String[] romnm = split(text, '\n');
						DataOutputStream os = null;
						try {
							os = Connector.openDataOutputStream(
								"scratchpad:///0;pos="
									+ (SIZE_SP_SETTING)
									+ ",length=" + SIZE_ROM_NAME * MAX_SDROM_PAGE * NUM_SDROM);
							for (int i=0; i<romnm.length; i++) {
								if (i > NUM_SDROM * sdPage_ - 1) break;
								os.write(formatSpace(romnm[i], SIZE_ROM_NAME).getBytes());
							}
							os.flush();
						} catch (Exception e) {
							alert("err writeInportSP: " + e);
						} finally {
							try {
								os.close();
								os = null;
							} catch (Exception ex) {
								os = null;
							}
						}
						messageStr = "";
					}
					repaint();
					break;
				case MODE_MENU_CHEAT_SET :
					boolean errf = true;
					String errstr = "";
					if (selectSubMenuNo_ == 0) {
						chtTxt = text;
						if (text.equals("")) break;
						if (text.length() >= 9){
							String[] chtstr = split(text, '\n');
							for (int i = 0; i < chtstr.length; i++){
								errstr = chtstr[i];
								if (chtstr[i].length() >= 8){
									try {
										int cht_type = Integer.parseInt(chtstr[i].substring(0, 1), 16);
										int cht_bank = Integer.parseInt(chtstr[i].substring(1, 2), 16);
										int cht_value = Integer.parseInt(chtstr[i].substring(2, 4), 16);
										int cht_adr = Integer.parseInt(chtstr[i].substring(4, 6), 16);
										int cht_adr2 = Integer.parseInt(chtstr[i].substring(6, 8), 16);
										if (cht_type != 0x9) {
											gbcore.mem_write(cht_adr + (cht_adr2 * 0x100),cht_value);
											errf = false;
											chtTemp = true;
										} else {
											break;
										}
									} catch (Exception e) {
										break;
									}
								} else {
									break;
								}
							}
						}else{
							errstr = text;
						}
					} else {
					// ɏ
					int i;
						switch (selectSubMenuNo_) {
							case 4 :
								i = 1;
								break;
							case 6 :
								i = 2;
								break;
							case 8 :
								i = 3;
								break;
							default :
								i = 0;
								break;
						}
						chtTxt2 = text;
						if (text.equals("")) break;
						if (text.length() >= 8){
							String chtstr = text;
							errstr = chtstr;
							if (chtstr.length() >= 8){
								try {
									int cht_type = Integer.parseInt(chtstr.substring(0, 1), 16);
									int cht_bank = Integer.parseInt(chtstr.substring(1, 2), 16);
									int cht_value = Integer.parseInt(chtstr.substring(2, 4), 16);
									int cht_adr = Integer.parseInt(chtstr.substring(4, 6), 16);
									int cht_adr2 = Integer.parseInt(chtstr.substring(6, 8), 16);
									if (chtType[i] != 0x9) {
										errf = false;
										chtType[i]= Integer.parseInt(chtstr.substring(0, 2), 16);
										chtVal[i] = Integer.parseInt(chtstr.substring(2, 4), 16);
										chtAdr[i] = Integer.parseInt(chtstr.substring(4, 6), 16);
										chtAdr2[i] = Integer.parseInt(chtstr.substring(6, 8), 16);
										chtSw[i] = true;
									} else {
										break;
									}
								} catch (Exception e) {
									break;
								}
							} else {
								break;
							}
						}else{
							errstr = text;
						}
					}
					if (errf) alert("`[gR[hG[\n" + errstr);
					repaint();
					break;
			}
		}
	}

	public void paint(Graphics g) {
		g.setFont(DEFAULT_FONT);
		try {
			if (mode_ == MODE_GAME || mode_ == MODE_ZOOM_SET) {
				if (displayClear) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, 0, getWidth(), getHeight());
					allG.setFlipMode(Graphics.FLIP_NONE);
					allG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					allG.fillRect(0, 0, getWidth(), getHeight());
					displayClear = false;
				}
				switch (flipModeKey_) { //]
					case 0 : //cJFʏAJF
						//g.setFlipMode(Graphics.FLIP_NONE);
						switch (zoom_) {
							case 0 : //ʏ
								fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								disp.vrt(g, messageStr, fpsDisp_ );
								break;
							case 1 : //g
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.vrt_large(g, messageStr, fpsDisp_, Anti_Alias_);
								break;
							case 2 : //Ch 240*320
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.vrt_wide(g, messageStr, fpsDisp_, Anti_Alias_);
								break;
							case 3 : //t
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.vrt_full(g, messageStr, fpsDisp_, Anti_Alias_);
								break;
							default : //t[
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.vrt_free(g, pos_x[1], pos_y[1], pos_x[0], pos_y[0], messageStr, fpsDisp_, Anti_Alias_);
								break;
						}
						break;

					case 1 : //cJFEAJFʏ Po[XAF|
						//g.setFlipMode(Graphics.FLIP_NONE);
						switch (svZoom_) {
							case 0 : //ʏ
								fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								disp.hrz(g, messageStr, fpsDisp_ );
								break;
							case 1 : //g
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.hrz_large(g, messageStr, fpsDisp_, Anti_Alias_);
								break;
							case 2 : //Ch
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.hrz_wide(g, messageStr, fpsDisp_, Anti_Alias_);
								break;
							case 3 : //t
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.hrz_full(g, messageStr, fpsDisp_, Anti_Alias_);
								break;
							default : //t[
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.hrz_free(g, pos_x[1], pos_y[1], pos_x[0], pos_y[0], messageStr, fpsDisp_, Anti_Alias_);
								break;
						}
						break;
					case 2 : //cJF180AJFE Ch]Ȃ
						allG.setFlipMode(Graphics.FLIP_NONE);
						switch (zoom_) {
							case 0 : //ʏ
								fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								disp.vrt(allG, messageStr, fpsDisp_);
								break;
							case 1 : //g
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.vrt_large(allG, messageStr, fpsDisp_, Anti_Alias_);
								break;
							case 2 : //Ch 240*320
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.vrt_wide(allG, messageStr, fpsDisp_, Anti_Alias_);
								break;
							case 3 : //t
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.vrt_full(allG, messageStr, fpsDisp_, Anti_Alias_);
								break;
							default : //t[
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.vrt_free(allG, pos_x[1], pos_y[1], pos_x[0], pos_y[0], messageStr, fpsDisp_, Anti_Alias_);
								break;
						}
						g.setFlipMode(Graphics.FLIP_ROTATE);
						g.drawImage(allImg, 0, 0);
						break;
					case 3 : //cJFAJF180 FE|
						allG.setFlipMode(Graphics.FLIP_NONE);
						switch (svZoom_) {
							case 0 : //ʏ
								fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								disp.hrz(allG, messageStr, fpsDisp_);
								break;
							case 1 : //g
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.hrz_large(allG, messageStr, fpsDisp_, Anti_Alias_);
								break;
							case 2 : //Ch
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.hrz_wide(allG, messageStr, fpsDisp_, Anti_Alias_);
								break;
							case 3 : //t
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.hrz_full(allG, messageStr, fpsDisp_, Anti_Alias_);
								break;
							default : //t[
								if (Anti_Alias_) {
									fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
								} else {
									fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
								}
								disp.hrz_free(allG, pos_x[1], pos_y[1], pos_x[0], pos_y[0], messageStr, fpsDisp_, Anti_Alias_);
								break;
						}
 						g.setFlipMode(Graphics.FLIP_ROTATE);
						g.drawImage(allImg, 0, 0);
						break;
					default :
						break;
				}
				if (mode_ == MODE_ZOOM_SET) {
					try {
						setSoftLabelVisible(true);
					} catch (Exception e) {}
					g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0x80));
					g.fillRect(0, 0, getWidth(), getHeight());
					if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 4) {
						String wxh = pos_x[0] + "x" + pos_y[0];
						int x = pos_x[1] + pos_x[0];
						int y = pos_y[1] + pos_y[0] - DEFAULT_FONT.getHeight();
						int wxhWidth = DEFAULT_FONT.stringWidth(wxh);
						if ((width - x) < wxhWidth) x = width - wxhWidth;
						if (y < 0) y = 0;
						int black = Graphics.getColorOfName(Graphics.BLACK);
						int green = Graphics.getColorOfName(Graphics.GREEN);
						int white = Graphics.getColorOfName(Graphics.WHITE);
						int yellow = Graphics.getColorOfName(Graphics.YELLOW);
						String m, nm;
						if (zoomSizeMode_) {
							m = "ރ[h";
							nm = "ʒu[h";
						} else {
							m = "ʒu[h";
							nm = "ރ[h";
						}
						if (flipModeKey_ == 0) { //cʎ
							disp.drawString2(g, black, green, wxh, x, y);
							disp.drawString2(g, black, yellow, m , 0, height - DEFAULT_FONT.getHeight());
							disp.drawString2(g, black, white, "(跰 \"" + nm + "\")" , DEFAULT_FONT.stringWidth(m), height - DEFAULT_FONT.getHeight());
						} else if (flipModeKey_ == 1) {
							disp.drawString(g, black, green, wxh, x, y);
							disp.drawString(g, black, yellow, m , 0, height - DEFAULT_FONT.getHeight());
							disp.drawString(g, black, white, "(跰 \"" + nm + "\")" , DEFAULT_FONT.stringWidth(m), height - DEFAULT_FONT.getHeight());
						} else if (flipModeKey_ == 2) { //c180x]
							// ]蔲 Ȃ񂩂ǂ܂
							disp.drawString2(allG, black, green, wxh, x, y);
							disp.drawString2(allG, black, yellow, m , 0, height - DEFAULT_FONT.getHeight());
							disp.drawString2(allG, black, white, "(跰 \"" + nm + "\")" , DEFAULT_FONT.stringWidth(m), height - DEFAULT_FONT.getHeight());
						} else if (flipModeKey_ == 3) {
							// ]蔲
							disp.drawString(allG, black, green, wxh, x, y);
							disp.drawString(allG, black, yellow, m , 0, height - DEFAULT_FONT.getHeight());
							disp.drawString(allG, black, white, "(跰 \"" + nm + "\")" , DEFAULT_FONT.stringWidth(m), height - DEFAULT_FONT.getHeight());
						}
					}
				}
				//g.unlock(true);
			} else if (mode_ == MODE_NONE) {
			//Ȃ
			} else {
				try {
					setSoftLabelVisible(true);
				} catch (Exception e) {}
				if (isReverse()) {
					MY_KEY_LEFT = Display.KEY_UP;
					MY_KEY_UP = Display.KEY_RIGHT;
					MY_KEY_RIGHT = Display.KEY_DOWN;
					MY_KEY_DOWN = Display.KEY_LEFT;
				} else {
					MY_KEY_LEFT = Display.KEY_LEFT;
					MY_KEY_UP = Display.KEY_UP;
					MY_KEY_RIGHT = Display.KEY_RIGHT;
					MY_KEY_DOWN = Display.KEY_DOWN;
				}
				paintRootMenu(menuG);
				g.lock();
				int mw = paintMenuImage(menuImg, mscale, 0, 0, MENU_WIDTH, MENU_HEIGHT);
				if (mode_ == MODE_DIALOG && !dialogReleased) {
					switch (dialogMode) {
						case Dialog.DIALOG_ERROR :
							myDialog(dialogMessage, "G[I", g.getColorOfRGB(255,0,127), "nj", "", mw);
							break;
						case Dialog.DIALOG_INFO :
							myDialog(dialogMessage, "", g.getColorOfRGB(0,127,255), "nj", "", mw);
							break;
						case Dialog.DIALOG_YESNO :
							myDialog(dialogMessage, "mF", g.getColorOfRGB(180,230,230), "͂", "", mw);
							break;
					}
					if (!dialogShowed) dialogShowed = true;
					paintMenuImage(menuImg, mscale, 0, 0, MENU_WIDTH, MENU_HEIGHT);
				}
				g.unlock(true);
				dialogNotReady = false;

				// ݒ@Iʂ\Ă_~[t@C쐬B
				if (!firstExec) {
					messageStr = "_~[t@C(y[W" + sdPage_ + ")쐬c";
					setMessage(messageStr);
					createSdfiles(1);
					messageStr = "";
					firstExec = true;
					initSoundSettings();
					writeSP();
					repaint();
				}
			}
		} catch (Exception ex) {
		}
	}

	private int paintMenuImage(final Image img, final int sc, final int x, final int y, int width, int height) {
		// XXX - Ȃ
		int w = width;
		int h = height;
 		//g.lock();
		if (widedisplay_) {
			if (isReverse()) {
				if (w/sc > getWidth()) w = getWidth() * sc;
				if (h/sc > getHeight()) h = getHeight() * sc;
				g.setFlipMode(Graphics.FLIP_NONE);
				g.drawScaledImage(img, x, y, w/sc, h/sc, 0, 0, w, h);
			} else if (isRotate() == 0) {
				if (w/sc > getHeight()) w = getHeight() * sc;
				if (h/sc > getHeight()) h = getHeight() * sc;
				g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
				g.drawScaledImage(img, (getWidth() - getHeight()) / 2 + getHeight() - y - h/sc, getHeight() - x - w/sc, w/sc, h/sc, 0, 0, w, h);
			} else if (isRotate() > 0) {
				if (w/sc > getWidth()) w = getWidth() * sc;
				if (h/sc > getHeight()) h = getHeight() * sc;
				g.setFlipMode(Graphics.FLIP_NONE);
				g.drawScaledImage(img, x, y, w/sc, h/sc, 0, 0, w, h);
			} else {
				if (w/sc > getHeight()) w = getHeight() * sc;
				if (h/sc > getHeight()) h = getHeight() * sc;
				g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
				g.drawScaledImage(img, (getWidth() - getHeight()) / 2 + y, getHeight() - x - w/sc, w/sc, h/sc, 0, 0, w, h);
			}
		} else {
			if (isReverse()) {
				if (w/sc > getHeight()) w = getHeight() * sc;
				if (h/sc > getWidth()) h = getWidth() * sc;
				g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
				g.drawScaledImage(img, getWidth() - y - h/sc, x, w/sc, h/sc, 0, 0, w, h);
			} else if (isRotate() == 1) {
				if (w/sc > getHeight()) w = getHeight() * sc;
				if (h/sc > getWidth()) h = getWidth() * sc;
				g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
				g.drawScaledImage(img, getWidth() - y - h/sc, x, w/sc, h/sc, 0, 0, w, h);
			} else if (isRotate() == 2) {
				if (w/sc > getHeight()) w = getHeight() * sc;
				if (h/sc > getWidth()) h = getWidth() * sc;
				g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
				g.drawScaledImage(img, y, x, w/sc, h/sc, 0, 0, w, h); 
			} else {
				if (w/sc > getWidth()) w = getWidth() * sc;
				if (h/sc > getWidth()) h = getWidth() * sc;
				g.setFlipMode(Graphics.FLIP_NONE);
				g.drawScaledImage(img, x, (getHeight() - getWidth()) / 2 + y, w/sc, h/sc, 0, 0, w, h);
			}
		}
		//g.unlock(true);
		// Ȃ肾Aj[ʂ̉ԂĂƂ낢𗧂
		return w;
	}

	private void paintRootMenu(final Graphics g) {
		g.lock();
		switch (mode_) {
			case MODE_MENU_ROOT :
				subMenu =
					new String[] {
						"ROMI",
						"Xe[g[h",
						"Xe[gZ[u",
						"Zbg",
						"Sʐݒ",
						"pbhݒ",
						"pbh@\ݒ",
						"ȈՃ`[g",
						"̑@\",
						"SPLbV",
						"o[W"
					};
				menu(g, "Cj[", subMenu, selectMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("o[W")+20*scale);
				break;

			case MODE_MENU_ROM :
				subMenu = subMenuRom;
				menu(g, "ROMI (PAGE " + page_ + "/" + sdPage_ + ")", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("                              ")+20*scale);
				if (menuBGcolor_ >= 3) {
					messageStr = "(PAGE " + page_ + "/" + sdPage_ + ")";
				}
				break;

			case MODE_MENU_LOAD :
				subMenu = saveStr_;
				menu(g, "Xe[g[h", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("                                  ")+20*scale);
				break;

			case MODE_MENU_SAVE :
				subMenu = saveStr_;
				menu(g, "Xe[gZ[u", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("                                  ")+20*scale);
				break;

			case MODE_MENU_SETTING :
				subMenu =
					new String[] {
						"FPS\         : " + ON_OFF_STR[!fpsOff_ ? (1) : (0)] + FPSDISP_STR[fpsDisp_],
						"t[XLbv    : " + frameskip,
						"x(60FPS)   : " + FRAMES_STR[sleep_],
						"NOROMǍ   : " + ON_OFF_STR[LoadRomFirst ? (1) : (0)],
						"Q[ʂ̉]    : " + FLIPMODE_STR[flipMode_],
						"TEho        : " + SOFTKEY_SOUND_STR[soundEnable_ ? (1) : (0)].trim(),
						"E\tgL[̋@\  : " + SOFTKEY_STR[rSoftkey_],
						"j[̓    : " + ON_OFF_STR[alpha ? (1) : (0)],
						"I[fBIڍאݒ",
						"ROMt@Cݒ",
						"mFbZ[Wݒ",
						"̑ݒ"
						};
				menu(g, "Sʐݒ", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("FPS\         : ON(X^bN)")+20*scale);
				break;

			case MODE_MENU_SOFTKEY :
				subMenu = SOFTKEY_STR;
				menu(g, "E\tgL[̋@\ : " + SOFTKEY_STR[rSoftkey_], subMenu, selectSubMenuNo_, 
					MENU_DEFAULT_FONT.stringWidth("pbhݒ")+20*scale);
				break;

			case MODE_PAD_SET :
			case MODE_PAD_SET_NOW :
				subMenu =
					new String[] {
						"L[         : " + KEY_STR[key[KEY_UP]],
						"L[         : " + KEY_STR[key[KEY_DOWN]],
						"L[         : " + KEY_STR[key[KEY_LEFT]],
						"L[         : " + KEY_STR[key[KEY_RIGHT]],
						"A{^        : " + KEY_STR[key[KEY_A]],
						"B{^        : " + KEY_STR[key[KEY_B]],
						"START{^    : " + KEY_STR[key[KEY_ST]],
						"SELECT{^   : " + KEY_STR[key[KEY_SE]],
						"A{^A      : " + KEY_STR[key[KEY_A2]],
						"B{^A      : " + KEY_STR[key[KEY_B2]],
						"START{^A  : " + KEY_STR[key[KEY_ST2]],
						"SELECT{^A : " + KEY_STR[key[KEY_SE2]]
						};
				menu(g, "pbhݒ -ʏ-", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("L[         : CAMERA_ZOOM_OUT")+20*scale);
				break;

			case MODE_PAD_SET_EX :
			case MODE_PAD_SET_NOW_EX :
				subMenu = 
					new String[] {
						"ڰѽ +1   : " + KEY_STR[key[KEY_FSU]],
						"ڰѽ -1   : " + KEY_STR[key[KEY_FSD]],
						"`̈ؑ   : " + KEY_STR[key[KEY_ZOOM]],
						"RAM Z[u     : " + KEY_STR[key[KEY_SAVE]],
						"Xe[gZ[u : " + KEY_STR[key[KEY_SS]],
						"Xe[g[h : " + KEY_STR[key[KEY_LS]],
						"ذݼ      : " + KEY_STR[key[KEY_SHOT]],
						"ȈՃ`[g     : " + KEY_STR[key[KEY_CHEAT]]
						};
				menu(g, "pbhݒ --", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("ڰѽ +1   : CAMERA_ZOOM_OUT")+20*scale);
				break;

			case MODE_MENU_BUTTON_SET :
				subMenu = 
					new String[] {
						"A{^A          : " + ON_OFF_STR[rapidA ? (1) : (0)],
						"A{^z[h      : " + ON_OFF_STR[holdA ? (1) : (0)],
						"A{^Aˁ{z[h",
						"B{^A          : " + ON_OFF_STR[rapidB ? (1) : (0)],
						"B{^z[h      : " + ON_OFF_STR[holdB ? (1) : (0)],
						"B{^Aˁ{z[h",
						"j[x         : " + neuroSense,
						"j[         : " + POINTER_STR[neuroWay ? (1) : (0)]
						};
				menu(g, "pbh@\ݒ", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("j[         : 4")+20*scale);
				break;

			case MODE_FUNC :
				subMenu = 
					new String[] {
						"SDRAMۑ",
						"SDRAMǍ",
						"XN[Vbg",
						"Q[ʐFύX    : " + GAME_COLOR[gamecolor_],
						"ڂ          : " + ON_OFF_STR[Anti_Alias_ ? (1) : (0)]
						};
				menu(g, "̑@\", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("Q[ʐFύX    : BrightSepia")+20*scale);
				break;

			case MODE_MENU_CHEAT_SET :
				String[] chtStr = new String[NUM_CHEAT];
				for (int m = 0; m < NUM_CHEAT; m++) {
					chtStr[m] = Integer.toHexString((chtType[m] * 0x1000000) + (chtVal[m] * 0x10000) + (chtAdr[m] * 0x100) + chtAdr2[m]);
					if (chtType[m] < 10) chtStr[m] = "0" + chtStr[m];
					if (chtStr[m].length() == 2) chtStr[m] = "--------";
				}
				subMenu =
					new String[] {
							"ꎞIɏ",
							"ɏ#1        : " + ON_OFF_STR[chtSw[0] ? (1) : (0)],
							"  " + chtStr[0],
							"ɏ#2        : " + ON_OFF_STR[chtSw[1] ? (1) : (0)],
							"  " + chtStr[1],
							"ɏ#3        : " + ON_OFF_STR[chtSw[2] ? (1) : (0)],
							"  " + chtStr[2],
							"ɏ#4        : " + ON_OFF_STR[chtSw[3] ? (1) : (0)],
							"  " + chtStr[3],
							"`[gR[hSDɕۑ",
							"`[gR[hSDǍ",
						};
				menu(g, "ȈՃ`[g", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("ɏ#1        : OFF")+20*scale);
				break;

			case MODE_MENU_AUDIO_SET :
				if(cursound <= 3) {
					subMenu =
						new String[] {
							"TEh[h      : " + SOUND_STR[cursound],
							"obt@JEg    : " + soundBufCount_,
							"Ch1-`go      : " + ON_OFF_STR[soundChEnable_[0] ? (1) : (0)],
							"Ch2-`go      : " + ON_OFF_STR[soundChEnable_[1] ? (1) : (0)],
							"Ch3-Opgo      : " + ON_OFF_STR[soundChEnable_[2] ? (1) : (0)],
							"Ch4-mCYo      : " + ON_OFF_STR[soundChEnable_[3] ? (1) : (0)],
							"1/8`gF       : " + (soundToneNum_[0] + 1),
							"1/4`gF       : " + (soundToneNum_[1] + 1),
							"1/2`gF       : " + (soundToneNum_[2] + 1),
							"OpgF          : " + (soundToneNum_[3] + 1),
							"mCYF          : " + (soundToneNum_[4] + 1),
							"ʐݒl          : " + soundVolume_ + "%"
						};
				} else {
					subMenu =
						new String[] {
							"TEh[h      : " + SOUND_STR[cursound],
							"o̓Tv[g  : " + SOUND_RATE_ARRAY[soundSampleRate_],
							"xύX            : " + SOUND_DELAY_STR[soundDelay_],
/*
							"obt@JEg    : " + PCM_SoundBufCount_,
							"Apuo̓tB^     : " + SOUND_FILTER_STR[soundApuFilter],
*/
							"`l1         : " + ON_OFF_STR[PCM_soundChannelEnable_[0] ? (1) : (0)],
							"`l2         : " + ON_OFF_STR[PCM_soundChannelEnable_[1] ? (1) : (0)],
							"`l3         : " + ON_OFF_STR[PCM_soundChannelEnable_[2] ? (1) : (0)],
							"`l4         : " + ON_OFF_STR[PCM_soundChannelEnable_[3] ? (1) : (0)],
							"ʐݒl          : " + soundVolume_ + "%"
						};
				}
				menu(g, "I[fBIڍאݒ", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("TEh[h      : SH252i(PCM)")+20*scale);
				break;
					
			case MODE_MENU_ROMFILE :
				subMenu =
				new String[] {
							"SDt@C쐬(+1y[W)",
							"SDt@C폜(-1y[W)",
							"ROM̂̃GNX|[g",
							"ROM̂̃C|[g",
							"SDJ[h󂫗eʂ̊mF"
/*
							"---------------------------",
							"SPROMLbV : " + ON_OFF_STR[noRomCache_?(0):(1)],
							"SPk[h   : " + (compressMode_ + 1),
							"SPk     : " + (noCompress_ ? "k" : "kL"),
							"SPœK",
							"SP",
							"SP󂫗eʂ̊mF"
*/
				};
				menu(g, "ROMt@Cݒ :  " + sdPage_ + "PAGE" , subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("SDt@C쐬(+1y[W)")+20*scale);
				break;

			case MODE_MENU_CONFIRM :
				subMenu =
				new String[] {
							"f[^[h      : " + ON_OFF_STR[confirmMsg_ & 1],
							"f[^Z[u      : " + ON_OFF_STR[(confirmMsg_ & 2) >> 1],
							"I              : " + ON_OFF_STR[(confirmMsg_ & 4) >> 2],
							"`[gǍ        : " + ON_OFF_STR[(confirmMsg_ & 8) >> 3],
							"`[gۑ        : " + ON_OFF_STR[(confirmMsg_ & 16) >> 4],
							"Lׂ"
				};
				menu(g, "mFbZ[Wݒ", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("f[^[h      : OFF")+20*scale);
				break;

			case MODE_MENU_SP_CACHE :
				subMenu =
				new String[] {
							"ROMۑ",
							"ROMǂݍ",
				};
				menu(g, "ROMLbV", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("ROMۑ")+20*scale);
				break;

			case MODE_MENU_OTHER_SET :
				subMenu =
				new String[] {
							"ްђ̷ٕ\  : " + ON_OFF_STR[showSoftLabel_ ? (1) : (0)],
							"ްђ̿ķ : " + ((float)wt_on_game_ / 1000) + "(b)",
							"`گ̳  : " + ((float)wt_on_refresh_ / 1000) + "(b)",
							"QVGAVGA̫Ăg : " + ON_OFF_STR[use_vgafont_ ? (1) : (0)],
							"Ӱ(P)   : " + ON_OFF_STR[reverseEnable_ ? (1) : (0)],
							"ӰӰ(F)  : " + ON_OFF_STR[rotateEnable_ ? (1) : (0)],
							"gp޲۸ނ   : " + DIALOG_STR[dialogType_]
				};
				menu(g, "̑ݒ", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("ްђ̿ķ : Ǝ(DojaF)")+20*scale);
				break;

			case MODE_MENU_ROMINFO :
				subMenu =
				new String[] {
							"ROM        : " + gbcore.rom_name,
							"MBC^Cv    : " + info_mbc,
							"v@\     : " + ON_OFF_STR[gbcore.rtc_batt ? (1) : (0)],
							"ROM^Cv    : " + HW_CGB_STR[gbcore.hw_cgb ? (1) : (0)]
				};
				menu(g, "ROM", subMenu, selectSubMenuNo_,
					MENU_DEFAULT_FONT.stringWidth("                                  ")+20*scale);
				break;

			default :
				break;
		}
		// 
		g.setColor(Graphics.getColorOfName(Graphics.BLACK));
		g.fillRect(0, 224 * scale, MENU_WIDTH, 16 * scale);
		if (messageStr != null) {
			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			g.drawString(messageStr, 4 * scale, 224 * scale + BASE_LINE);
		}
		g.unlock(true);
	}

	/*
	* drawMsg(), drawcTriangle(), drawChs()  Shoelace 炢܂ m(_ _)mZMo[Ŵ̂܂܎gĂ܂B݂܂
	*/
	//bZ[W\GA̕`
	public void drawMsg(final Graphics g, int xp,int yp,int whd,int hgt){
		//bZ[W\̘g`
		int[] x={xp,xp+2,xp+whd-2,xp+whd,xp+whd,xp+whd-2,xp+2,xp,xp};
		int[] y={yp+2,yp,yp,yp+2,yp+hgt-2,yp+hgt,yp+hgt,yp+hgt-2,yp+2};
		int[] x2={xp-1,xp+2,xp+whd-2,xp+whd+1,xp+whd+1,xp+whd-2,xp+2,xp-1,xp-1};
		int[] y2={yp+2,yp-1,yp-1,yp+2,yp+hgt-2,yp+hgt+1,yp+hgt+1,yp+hgt-2,yp+2};

		//bZ[W\lCr[œhԂ
		g.setColor(g.getColorOfRGB(0x33,0x33,0x77,0xCF));
		g.fillRect(xp,yp,whd,hgt);

		//bZ[Wg\
		g.setColor(g.getColorOfRGB(0x88,0x88,0x88));
		g.drawPolyline(x,y,9);
		g.setColor(g.getColorOfRGB(0xCC,0xCC,0xCC));
		g.drawPolyline(x2,y2,9);
	}

	//J[\̕`
	public void drawcTriangle(final Graphics g, int xp,int yp){
		int[] x={xp,xp+6*scale,xp,xp};
		int[] y={yp,yp+4*scale,yp+8*scale,yp};

		g.setColor(g.getColorOfRGB(0xFF,0xFF,0xFF));
		g.fillPolygon(x,y,4);
	}

	//EBhE̕`
	public void drawChs(final Graphics g, String[] sChois, int x, int y, int whd){
		g.setFont(MENU_DEFAULT_FONT);
		int myp = y + HEIGHT_LINE;
		drawMsg(g, x,y,whd,(HEIGHT_LINE*sChois.length)+7*scale);
		g.setColor(g.getColorOfRGB(0xFF,0xFF,0xFF));
		for(int i=0; i<sChois.length; i++) g.drawString(sChois[i], x + 17 * scale, myp + (i * HEIGHT_LINE));
	}

	private void menu(final Graphics g, String title, final String[] menu, final int select, final int windowWidth) {
		//g.setFont(DEFAULT_FONT);
		g.setColor(Graphics.getColorOfName(Graphics.BLACK));
		g.fillRect(0, 0, MENU_WIDTH, MENU_HEIGHT);
		// wiF
		if (alpha) {
			if (!romload) {
				if (isReverse()||isRotate() > 0) {
					g.drawScaledImage(img, 0, 0, MENU_WIDTH, 224 * scale, 0, 0, 320, 224);
				} else {
					g.drawScaledImage(img, 0, 0, 240 * scale, 224 * scale, 80, 0, 240, 224);
				}
			} else {
				if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) == 0) {
					fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
					if (isReverse()||isRotate() > 0) {
						g.drawScaledImage(fb2, (MENU_WIDTH - 160 * scale) / 2, (MENU_HEIGHT - 160 * scale) / 2, 160 * scale, 144 * scale, 0, 0, 160, 144);
					} else {
						g.drawScaledImage(fb2, 40 * scale, 40 * scale, 160 * scale, 144 * scale, 0, 0, 160, 144);
					}
				} else {
					if (Anti_Alias_) {
						fb2G.setRGBPixels(0, 0, 240, 216, fb, 0);
						if (isReverse()||isRotate() > 0) {
							g.drawScaledImage(fb2, (MENU_WIDTH - 240 * scale) / 2, 4 * scale, 240 * scale, 216 * scale, 0, 0, 240, 216);
						} else {
							g.drawScaledImage(fb2, 0, 4 * scale, 240 * scale, 216 * scale, 0, 0, 240, 216);
						}
					} else {
						fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
						if (isReverse()||isRotate() > 0) {
							g.drawScaledImage(fb2, (MENU_WIDTH - 240 * scale) / 2, 4 * scale, 240 * scale, 216 * scale, 0, 0, 160, 144);
						} else {
							g.drawScaledImage(fb2, 0, 4 * scale, 240 * scale, 216 * scale, 0, 0, 160, 144);
						}
					}
				}
			}
			if ((menuBGcolor_ % 3) == 0) { // 0, 3
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x44, 0xCF));
			}else if ((menuBGcolor_ % 3) == 1) { // 1, 4
				g.setColor(Graphics.getColorOfRGB(0x22, 0x22, 0x22, 0xCF));
			}else { // 2, 5
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
			}
		} else {
			if ((menuBGcolor_ % 3) == 0) { // 0, 3
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x55));
			} else if ((menuBGcolor_ % 3) == 1) { // 1, 4
				g.setColor(Graphics.getColorOfRGB(0x33, 0x33, 0x33));
			} else { // 2, 5
				g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
			}
		}
		if (menuBGcolor_ >= 3) {
			g.fillRect(0, 0, MENU_WIDTH, MENU_HEIGHT);
			//ShoelaceEBhE
			int shoeX = 5 * scale;
			int shoeY = 5 * scale;
			if (isReverse())
				shoeX += (MENU_WIDTH - 320 * scale) / 2;
			drawChs(g, menu, shoeX, shoeY, windowWidth);
			drawcTriangle(g, shoeX + 5 * scale, HEIGHT_LINE * (select + 1) - 5 * scale);
		} else {
			g.fillRect(0, HEIGHT_LINE, MENU_WIDTH, MENU_HEIGHT - HEIGHT_LINE - 16 * scale);
			//j[^CgF
			if (menuBGcolor_ == 0) {
				g.setColor(Graphics.getColorOfRGB(0x55, 0x55, 0xAA));
			} else if (menuBGcolor_ == 1) {
				g.setColor(Graphics.getColorOfRGB(0x88, 0x88, 0x88));
			} else {
				g.setColor(Graphics.getColorOfRGB(0xA, 0x0F, 0x41));
			}
			g.fillRect(0, 0, MENU_WIDTH, HEIGHT_LINE);
			g.setColor(Graphics.getColorOfName(Graphics.BLACK));
			g.drawString(title, 2 * scale, BASE_LINE);
			g.drawString(title, 3 * scale, BASE_LINE - 1 * scale);
			g.drawString(title, 4 * scale, BASE_LINE);
			g.drawString(title, 3 * scale, BASE_LINE + 1 * scale);
			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			g.drawString(title, 3 * scale, BASE_LINE);

			for (int i = 0; i < menu.length; i++) {
				//Io[̐F
				if (i == select) {
					if (menuBGcolor_ == 0) {
						g.setColor(Graphics.getColorOfRGB(0xdd, 0xdd, 0xff));
					} else if (menuBGcolor_ == 1) {
						g.setColor(Graphics.getColorOfRGB(0xdd, 0xdd, 0xdd));
					} else if (menuBGcolor_ == 2) {
						g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0xC0));
					}
					g.fillRect(0, HEIGHT_LINE * (i + 1), MENU_WIDTH, HEIGHT_LINE);
				//I̕F
					if (menuBGcolor_ == 0) {
						g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x88));
					} else if (menuBGcolor_ == 1) {
						g.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00));
					} else if (menuBGcolor_ == 2) {
						g.setColor(Graphics.getColorOfRGB(0xff, 0xff, 0xff));
					}
				} else {
				//I̕F
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
				}
				// j[
				String num;
				if (i < 10) {
					num = "[" + (i + 1) % 10 + "] ";
				} else {
					switch (i){
						case 10 :
							num = "[*] ";
							break;
						case 11 :
							num = "[#] ";
							break;
						default :
							num = "[-] ";
							break;
					}
				}
				String romno = "";
				if (mode_ == MODE_MENU_ROM){
					romno = formatNumber((page_ - 1) * NUM_SDROM + i + 1, 3) + " ";
				}
				g.drawString(num + romno + menu[i], 4 * scale, HEIGHT_LINE * (i + 1) + BASE_LINE);
			}
		}
	}

	private void selectMenuConfirm() {
		// mFbZ[Wݒ
		switch (selectSubMenuNo_) {
			case 0 :
				confirmMsg_ ^= 1;
				break;
			case 1 :
				confirmMsg_ ^= 2;
				break;
			case 2 :
				confirmMsg_ ^= 4;
				break;
			case 3 :
				confirmMsg_ ^= 8;
				break;
			case 4 :
				confirmMsg_ ^= 16;
				break;
			default :
				if ((confirmMsg_ & 0xFF) == 0xC0) {
					confirmMsg_ = 0xFF;
				} else {
					confirmMsg_ = 0xC0;
				}
				break;
		}
		repaint();
	}

	private void padSetting(int i) {
		keyChange = i;
		key[i] = 62;
		repaint();
	}

	private void selectGamekey(int param) {
		for ( int kp = 0; kp < 24; kp++) {
			if (param == key[kp]) {
				switch (kp) {
					case KEY_UP :
						gbcore.pad_set(pad[kp], true);
						break;
					case KEY_DOWN :
						gbcore.pad_set(pad[kp], true);
						break;
					case KEY_LEFT :
						gbcore.pad_set(pad[kp], true);
						break;
					case KEY_RIGHT :
						gbcore.pad_set(pad[kp], true);
						break;
					case KEY_A :
					case KEY_A2 :
						if (!rapidA) gbcore.pad_set(0x10, true);
						else pressA = true;
						break;
					case KEY_B :
					case KEY_B2 :
						if (!rapidB) gbcore.pad_set(0x20, true);
						else pressB = true;
						break;
					case KEY_ST :
					case KEY_ST2 :
						gbcore.pad_set(0x80, true);
						break;
					case KEY_SE :
					case KEY_SE2 :
						gbcore.pad_set(0x40, true);
						break;
					default :
						break;
				}
			}
		}
	}

	private void selectGamekey2(int param) {
		for ( int kp = 0; kp < 24; kp++) {
			if (param == key[kp]) {
				switch (kp) {
					case KEY_FSU :
						frameskip++;
						if (frameskip > FS_max) frameskip = FS_min;
						gbcore.setFrameSkip(frameskip);
						writeSP();
						break;
					case KEY_FSD :
						frameskip--;
						if (frameskip < FS_min) frameskip = FS_max;
						gbcore.setFrameSkip(frameskip);
						writeSP();
						break;
					case KEY_ZOOM :
						gbcore.emu_running = false;
						padDisp_ = true;
						refreshDisplay();
						setSoftLabel(Frame.SOFT_KEY_1, " ߂ ");
						setSoftLabel(Frame.SOFT_KEY_2, ZOOM_STR[(flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_]);
						zoomSizeMode_ = true;
						mode_ = MODE_ZOOM_SET;
						if ((!isReverse() && flipMode_ == 2) || (isReverse() && flipMode_ == 1)) {
							//c(180)
							//FE|(180)@flipModeKey_3.flipMode_2@flipModeKey_1.flipMode_2
							//Po[X(E90)@flipModeKey_ = 2.flipMode_ = 1
							MY_KEY_LEFT = Display.KEY_RIGHT;
							MY_KEY_UP = Display.KEY_DOWN;
							MY_KEY_RIGHT = Display.KEY_LEFT;
							MY_KEY_DOWN = Display.KEY_UP;
						} else if (flipMode_ == 3 && !isReverse() || (isReverse() && flipMode_ == 2)) {
							//c(90)
							//FE|(90)@flipModeKey_0.flipMode_3@flipModeKey_2.flipMode_3
							//Po[X(180)@flipModeKey_ = 3.flipMode_ = 2
							MY_KEY_LEFT = Display.KEY_DOWN;
							MY_KEY_UP = Display.KEY_LEFT;
							MY_KEY_RIGHT = Display.KEY_UP;
							MY_KEY_DOWN = Display.KEY_RIGHT;
						} else if (flipMode_ == 1 || (isReverse() && flipMode_ != 3)) {
							//c(E90)
							//FE|(E90)@flipModeKey_2.flipMode_1@flipModeKey_0.flipMode_1
							//Po[X(])
							MY_KEY_LEFT = Display.KEY_UP;
							MY_KEY_UP = Display.KEY_RIGHT;
							MY_KEY_RIGHT = Display.KEY_DOWN;
							MY_KEY_DOWN = Display.KEY_LEFT;
						} else {
							//c(])
							//FE(])
							//Po[X(90)flipModeKey_ = 0.flipMode_ = 3
							MY_KEY_LEFT = Display.KEY_LEFT;
							MY_KEY_UP = Display.KEY_UP;
							MY_KEY_RIGHT = Display.KEY_RIGHT;
							MY_KEY_DOWN = Display.KEY_DOWN;
						}
						repaint();
						break;
					case KEY_SAVE :
						gbcore.emu_running = false;
						refreshDisplay();
						rYes = confirm("݂RAMeSDɕۑ܂?");
						if (rYes) {
							messageStr = " ۑłb҂";
							gbcore.saveRamToSD();
							resumeGame();
						} else {
							resumeGame();
						}
						messageStr = "";
						break;
					case KEY_LS :
						gbcore.emu_running = false;
						refreshDisplay();
						messageStr = "";
						mode_ = MODE_MENU_LOAD;
						selectMenuNo_ = 2;
						selectSubMenuNo_ = svSubMenuLoadNo;
						setSoftLabel( Frame.SOFT_KEY_2 , " o " );
						setSoftLabel( Frame.SOFT_KEY_1 , " ߂ " );
						repaint();
						break;
					case KEY_SS :
						gbcore.emu_running = false;
						refreshDisplay();
						messageStr = "";
						mode_ = MODE_MENU_SAVE;
						selectMenuNo_ = 3;
						selectSubMenuNo_ = svSubMenuSaveNo;
						setSoftLabel( Frame.SOFT_KEY_2 , "  " );
						setSoftLabel( Frame.SOFT_KEY_1 , " ߂ " );
						repaint();
						break;
					case KEY_SHOT :
						refreshDisplay();
						messageStr = "";
						saveScreenShot();
						break;
					case KEY_CHEAT :
						gbcore.emu_running = false;
						refreshDisplay();
						messageStr = "";
						mode_ = MODE_MENU_CHEAT_SET;
						setSoftLabel( Frame.SOFT_KEY_1 , " ߂ " );
						setSoftLabel( Frame.SOFT_KEY_2 , null);
						repaint();
						break;
					default :
						break;
				}
			}
		}
	}

	private void selectMenuRoot() {
		switch (selectMenuNo_) {
			case 0 : // ROMI
				setSoftLabel( Frame.SOFT_KEY_2 , "̕ҏW" );
				page_ = sdNo_ / NUM_SDROM + 1;
				selectSubMenuNo_ = sdNo_ % NUM_SDROM;
    			readSdromNameSP(page_);
				mode_ = MODE_MENU_ROM;
				break;
			case 1 : // LOAD
				selectSubMenuNo_ = svSubMenuLoadNo;
				setSoftLabel( Frame.SOFT_KEY_2 , " o " );
				mode_ = MODE_MENU_LOAD;
				break;
			case 2 :  // SAVE
				selectSubMenuNo_ = svSubMenuSaveNo;
				setSoftLabel( Frame.SOFT_KEY_2 , "  " );
				mode_ = MODE_MENU_SAVE;
				break;
			case 3 : // RESET
				boolean rYes = true;
				gbcore.emu_running = false;
				rYes = confirm("Zbg܂H");
				if (rYes) {
					if (romload) {
						gbcore.emu_reset();
						resumeGame();
					}
				}
				break;
			case 4 : // Sʐݒ
				selectSubMenuNo_ = svSubMenuSettingNo;
				setSoftLabel( Frame.SOFT_KEY_2 ,SOFTKEY_BGCOLOR_STR[menuBGcolor_]);
				mode_ = MODE_MENU_SETTING;
				break;
			case 5 : // KeyConfig
				selectSubMenuNo_ = svSubMenuKeyConfNo;
				setSoftLabel( Frame.SOFT_KEY_2 , "  " );
				mode_ = MODE_PAD_SET;
				break;
			case 6 : // {^@\ݒ
				selectSubMenuNo_ = svSubMenuPadNo;
				padDisp_ = false;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_BUTTON_SET;
				break;
			case 7 : // ȈՃ`[g
				selectSubMenuNo_ = svSubMenuCheatNo;
				padDisp_ = false;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_CHEAT_SET;
				break;
			case 8 : //̑ݒ
				selectSubMenuNo_ = svSubMenuOthersettingNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_FUNC;
				break;
			case 9 : //SPLbV
				selectSubMenuNo_ = svSubMenuSpCacheNo;
				setSoftLabel(Frame.SOFT_KEY_2, null);
				mode_ = MODE_MENU_SP_CACHE;
				break;
			case 10 : //o[W
				infomsg(versionStr);
				break;
			default :
				break;
		}
		repaint();
	}

	private void menuSetting(final int i) {
		switch (selectSubMenuNo_) {
			case 0 : //FPS\
				switch (i) {
					case SELECT :
					case RIGHT :
						if (++fpsDisp_ > 3) fpsDisp_ = 0;
						break;
					case LEFT :
						if (--fpsDisp_ < 0) fpsDisp_ = 3;
						break;
				}
				if (fpsDisp_ == 3) fpsOff_ = true;
				else fpsOff_ = false;
				break;
			case 1 : //t[XLbv
				switch (i) {
					case SELECT :
					case RIGHT :
						frameskip++;
						if (frameskip > FS_max) frameskip = FS_min;
						break;
					case LEFT :
						frameskip--;
						if (frameskip < FS_min) frameskip = FS_max;
						break;
				}
				gbcore.setFrameSkip(frameskip);
				break;
			case 2 : //x
				switch (i) {
					case SELECT :
					case RIGHT :
						sleep_++;
						if (sleep_ == 3) sleep_ = 0;
						break;
					case LEFT :
						sleep_--;
						if (sleep_ < 0) sleep_ = 2;
						break;
				}
				break;
			case 3 : //NOROMǍ
				LoadRomFirst = !LoadRomFirst;
				break;
			case 4 : //Q[ʉ]
				switch (i) {
					case SELECT :
					case RIGHT :
						flipMode_++;
						if (flipMode_ == 4) flipMode_ = 0;
						break;
					case LEFT :
						flipMode_--;
						if (flipMode_ < 0) flipMode_ = 3;
						break;
				}
				setFlipModeKey();
				break;
			case 5 : //TEho
				soundEnable_ = !soundEnable_;
				psgi.setSoundEnable(soundEnable_);
				gbcore.pcm.setSoundEnable(soundEnable_);
				break;
			case 6 : //E\tgL[̋@\
				switch (i) {
					case SELECT :
						selectSubMenuNo_ = rSoftkey_;
						mode_ = MODE_MENU_SOFTKEY;
						setSoftLabel(Frame.SOFT_KEY_2, null);
						break;
				}
				break;
			case 7 : //j[̓
				alpha = !alpha;
				break;
			case 8 : // I[fBIڍאݒ
				switch (i) {
					case SELECT :
						selectSubMenuNo_ = svSubMenuAudioNo;
						mode_ = MODE_MENU_AUDIO_SET;
						setSoftLabel(Frame.SOFT_KEY_2, "l" );
				}
				break;
			case 9 : //ROMt@Cݒ
				switch (i) {
					case SELECT :
						selectSubMenuNo_ = svSubMenuRomfileNo;
						mode_ = MODE_MENU_ROMFILE;
						setSoftLabel(Frame.SOFT_KEY_2, null);
				}
				break;
			case 10 : // mFbZ[W
				switch (i) {
					case SELECT :
						selectSubMenuNo_ = svSubMenuConfirmNo;
						mode_ = MODE_MENU_CONFIRM;
						setSoftLabel(Frame.SOFT_KEY_2, null);
				}
				break;
			case 11 : // ̑ݒ
				switch (i) {
					case SELECT :
						selectSubMenuNo_ = svSubMenuOtherNo;
						mode_ = MODE_MENU_OTHER_SET;
						setSoftLabel(Frame.SOFT_KEY_2, null);
				}
				break;
		}
		repaint();
	}

	private void selectMenuSoftkey() {
		// E\tgL[@\
		rSoftkey_ = selectSubMenuNo_;
		writeSP();
		selectSubMenuNo_ = 6;
		mode_ = MODE_MENU_SETTING;
		repaint();
	}

	private void setRightSoftkeyLabel() {
		switch (rSoftkey_) {
			case 0 :
				setSoftLabel(Frame.SOFT_KEY_2, "PADݒ" );
				break;
			case 1 :
				setSoftLabel(Frame.SOFT_KEY_2, "CHEAT" );
				break;
			case 2 :
				setSoftLabel(Frame.SOFT_KEY_2, "RESET" );
				break;
			case 3 :
				setSoftLabel(Frame.SOFT_KEY_2, SOFTKEY_SOUND_STR[soundEnable_ ? (1) : (0)]);
				break;
			case 4 :
				setSoftLabel(Frame.SOFT_KEY_2, "`ʗ̈" );
				break;
			case 5 :
				setSoftLabel(Frame.SOFT_KEY_2, "ROM" );
				break;
			default :
				setSoftLabel(Frame.SOFT_KEY_2, null);
		}
		//Q[̃x\Ȃ
		//ŕ\ݒ肵΂肾EEE
		try {
			setSoftLabelVisible(showSoftLabel_);
		} catch (Exception ex) {}
	}

	private void menuPadFunc (final int i) {
		switch (selectSubMenuNo_) {
			case 0 :
				rapidA = !rapidA;
				break;
			case 1 :
				holdA = !holdA;
				break;
			case 2 :
				switch (i) {
					case SELECT :
						if (rapidA && holdA) {
							rapidA = false;
							holdA = false;
						} else {
							rapidA = true;
							holdA = true;
						}
				}
				break;
			case 3 :
				rapidB = !rapidB;
				break;
			case 4 :
				holdB = !holdB;
				break;
			case 5 :
				switch (i) {
					case SELECT :
						if (rapidB && holdB) {
							rapidB = false;
							holdB = false;
						} else {
							rapidB = true;
							holdB = true;
						}
				}
				break;
			case 6 :
				try {
					PointingDevice.isAvailable();
					PointingDevice.setMode(PointingDevice.MODE_JOYSTICK);
					switch (i) {
						case SELECT :
							if (neuroSense < 128) {
								neuroSense += 1;
								PointingDevice.setEnabled(true);
							}
							if (neuroSense == 128) {
								neuroSense = 0;
								PointingDevice.setEnabled(false);
							}
							break;
						case RIGHT :
							if (neuroSense < 118) {
								neuroSense += 10;
								PointingDevice.setEnabled(true);
							} else if (neuroSense >= 118) {
								neuroSense = 127;
							}
							break;
						case LEFT :
							if (neuroSense > 10) {
								neuroSense -= 10;
								PointingDevice.setEnabled(true);
							} else if (neuroSense <= 10) {
								neuroSense = 0;
								PointingDevice.setEnabled(false);
							}
							break;
					}
				} catch (Exception ex) {
					alert("̋@\ƭ߲\n ڋ@ł̂ݗLłB");
				}
				break;
			case 7 :
				try {
					PointingDevice.isAvailable();
					neuroWay = !neuroWay;
				} catch (Exception ex) {
					alert("̋@\ƭ߲\n ڋ@ł̂ݗLłB");
				}
				break;
		}
		if (holdA) gbcore.pad_set(0x10, true);
		else gbcore.pad_set(0x10, false);
		if (holdB) gbcore.pad_set(0x20, true);
		else gbcore.pad_set(0x20, false);
		repaint();
	}



	private void menuFunc(final int i) {
		switch (selectSubMenuNo_) {
			case 0 : //RAMۑ
				switch (i) {
					case SELECT :
						if (romload) {
							rYes = confirm("݂RAMeSDɕۑ܂?");
								if (rYes) {
									messageStr = "ۑłb҂";
									gbcore.saveRamToSD();
									messageStr = "";
									repaint();
								}
						} else {
							alert("ROMǍłɂĂ!!");
						}
						break;
				}
				break;
			case 1 : //RAMǂݍ
				switch (i) {
					case SELECT :
						if (romload) {
							rYes = confirm("SDɕۑꂽRAMǍ݂܂?");
							if (rYes) {
								try {
									gbcore.loadRamFromSD();
								} catch (NullPointerException npe) {
									alert("SDRAMްL܂!!");
								}
							}
						} else {
							alert("ROMǍłɂĂ!!");
						}
						break;
				}
				break;
			case 2 : //XN[Vbg
				switch (i) {
					case SELECT :
						saveScreenShot();
						break;
				}
				break;
			case 3 :
				switch (i) {
					case SELECT :
					case RIGHT :
						gamecolor_ ++;
						if (gamecolor_ > 14) gamecolor_ = 0;
						break;
					case LEFT :
						gamecolor_ --;
						if (gamecolor_ < 0) gamecolor_ = 14;
						break;
				}
				gbcore.setGameColor(gamecolor_);
				break;
			case 4 :
				Anti_Alias_ = !Anti_Alias_;
				break;
			default :
				break;
		}
		repaint();
	}

	private void selectMenuOtherSetting(final int i) {
		switch (selectSubMenuNo_) {
			case 0 : // ްђ̷ٕ\
				showSoftLabel_ = !showSoftLabel_;
				break;
			case 1 : // ްђ̿ķ
				switch (i) {
					case SELECT :
						wt_on_game_ += 100;
						if (wt_on_game_ > 10000) wt_on_game_ = 0;
						break;
				}
				break;
			case 2 : // `گ̳
				switch (i) {
					case SELECT :
						wt_on_refresh_ += 100;
						if (wt_on_refresh_ > 10000) wt_on_refresh_ = 0;
						break;
				}
				break;
			case 3 : // QVGAʂłVGAtHgkĎg
				use_vgafont_ = !use_vgafont_;
				infomsg("ċNKvł");
				writeSP();
				break;
			case 4 : // ʃ[h
				reverseEnable_ = !reverseEnable_;
				setFlipModeKey();
				refreshDisplay();
				break;
			case 5 : // F̹
				rotateEnable_ = !rotateEnable_;
				setFlipModeKey();
				refreshDisplay();
				break;
			case 6 : // V_CAO
				switch (i) {
					case SELECT :
					case RIGHT :
						if (++dialogType_ > 2) dialogType_ = 0;
						break;
					case LEFT :
						if (--dialogType_ < 0) dialogType_ = 2;
						break;
				}
				break;

			default :
				break;
		}
		repaint();
	}

	private void menuCheat(final int i) {
        	boolean rYes = true;
		switch (selectSubMenuNo_) {
			case 0 :
				switch (i) {
					case SELECT :
						imeOn(chtTxt, TextBox.DISPLAY_ANY, TextBox.NUMBER);
						break;
				}
				break;
			case 2 :
			case 4 :
			case 6 :
			case 8 :
				switch (i) {
					case SELECT :
						imeOn(chtTxt2, TextBox.DISPLAY_ANY, TextBox.NUMBER);
						break;
				}
				break;
			case 1 :
				if (chtAdr2[0] != 0) chtSw[0] = !chtSw[0];
				break;
			case 3 :
				if (chtAdr2[1] != 0) chtSw[1] = !chtSw[1];
				break;
			case 5 :
				if (chtAdr2[2] != 0) chtSw[2] = !chtSw[2];
				break;
			case 7 :
				if (chtAdr2[3] != 0) chtSw[3] = !chtSw[3];
				break;
			case 9 :
				switch (i) {
					case SELECT :
						if (romload) {
							if (chtVal[0] != 0 || chtVal[1] != 0 || chtVal[2] != 0 || chtVal[3] != 0 || chtTemp) {
								if ((confirmMsg_ & 16) != 0) rYes = confirm("`[gR[hSDɕۑ܂?");
								if (rYes) {
									messageStr = "ۑłb҂";
									setMessage(messageStr);
									saveCheat();
									messageStr = "";
									repaint();
								}
							} else {
								alert("`[gR[hL܂!!");
							}
						} else {
							alert("ROMǍłɂĂ!!");
						}
					break;
				}
				break;
			case 10 :
				switch (i) {
					case SELECT :
						if (romload) {
							if ((confirmMsg_ & 8) != 0) rYes = confirm("`[gR[hSDǍ݂܂?");
							if (rYes) {
								messageStr = "Ǎłb҂";
								setMessage(messageStr);
								loadCheat();
								messageStr = "";
							}
						} else {
							alert("ROMǍłɂĂ!!");
						}
					break;
				}
				break;
			default :
				break;
		}
		repaint();
	}

	private void selectAudioSetting(final int i) {
		// I[fBIڍאݒ
		int ch = selectSubMenuNo_ - 2;
		int bank = selectSubMenuNo_ - 6;
		if(cursound <= 3) { // PSGTEh
			switch (selectSubMenuNo_) {
				case 0 ://TEh[h
					switch (i) {
						case SELECT :
						case RIGHT :
							cursound++;
							if(cursound > 6) cursound = 0;
							break;
						case LEFT :
							cursound--;
							if(cursound < 0) cursound = 6;
							break;
					}
					break;
				case 1 ://obt@[JEg
					switch (i) {
						case SELECT :
						case RIGHT :
							soundBufCount_++;
							if(soundBufCount_ > 60) soundBufCount_ = 15;
							break;
						case LEFT :
							soundBufCount_--;
							if(soundBufCount_ < 15) soundBufCount_ = 60;
							break;

					}
					break;
				case 2 ://`lIIt
				case 3 :
				case 4 :
				case 5 :
					soundChEnable_[ch] = !soundChEnable_[ch];
					break;
				case 6 :
				case 7 :
				case 8 :
				case 9 :
				case 10 :
					switch (i) {
						case SELECT :
							soundToneNum_[bank]++;
							if(soundToneNum_[bank] > 127) soundToneNum_[bank] = 0;
							break;
					}
					break;
				case 11 :
					switch (i) {
						case SELECT :
						case RIGHT :
							soundVolume_ += 10;
							if (soundVolume_ > 100) soundVolume_ = 0;
							break;
						case LEFT :
							soundVolume_ -= 10;
							if (soundVolume_ < 0) soundVolume_ = 100;
							break;
					}
					break;
				default :
					break;
			}
			//repaint();
		} else { //PCMTEh
			switch (selectSubMenuNo_) {
				case 0 : //TEh[h
					switch (i) {
						case SELECT :
						case RIGHT :
							cursound++;
							if(cursound > 6) cursound = 0;
							break;
						case LEFT :
							cursound--;
							if(cursound < 0) cursound = 6;
							break;
					}
					break;
				case 1 : //o̓Tv[g
					switch(i){
						case SELECT :
						case RIGHT :
							soundSampleRate_++;
							if(soundSampleRate_ > 2) soundSampleRate_ = 0;
							break;
						case LEFT :
							soundSampleRate_--;
							if(soundSampleRate_ < 0) soundSampleRate_ = 2;
							break;
					}
					gbcore.sound_reset();
					break;
				case 2 : //xlύX
					switch(i){
						case SELECT :
						case RIGHT :
							soundDelay_++;
							if(soundDelay_ > 3) soundDelay_ = 0;
							break;
						case LEFT :
							soundDelay_--;
							if(soundDelay_ < 0) soundDelay_ = 3;
							break;
					}
					break;

/*
				case 2 : //obt@t[
					switch(i){
						case SELECT :
						case RIGHT :
							PCM_SoundBufCount_++;
							if(PCM_SoundBufCount_ > 60) PCM_SoundBufCount_ = 15;
							break;
						case LEFT :
							PCM_SoundBufCount_--;
							if(PCM_SoundBufCount_ < 15) PCM_SoundBufCount_ = 60;
							break;
					}
					break;
				case 3 : //Apuo̓tB^
					switch(i){
						case SELECT :
						case RIGHT :
							soundApuFilter++;
							if (soundApuFilter > 2) soundApuFilter = 0;
							break;
						case LEFT :
							soundApuFilter--;
							if (soundApuFilter < 0) soundApuFilter = 2;
							break;
					}
					break;
*/
				case 3 : //PCMTEhChIIt
				case 4 :
				case 5 :
				case 6 :
					PCM_soundChannelEnable_[selectSubMenuNo_-3] = !PCM_soundChannelEnable_[selectSubMenuNo_-3];
					break;
				case 7 : // 
					switch (i) {
						case SELECT :
						case RIGHT :
							soundVolume_ += 10;
							if (soundVolume_ > 100) soundVolume_ = 0;
							break;
						case LEFT :
							soundVolume_ -= 10;
							if (soundVolume_ < 0) soundVolume_ = 100;
							break;
					}
					gbcore.pcm.setVolume(soundVolume_);
					break;
				default :
					break;
			}

		}
		repaint();
	}

	private void selectMenuSpcache() {
		try{
			switch (selectSubMenuNo_) {
				case 0 : // toSP
					mode_ = MODE_MENU_ROM;
					SPmode = true;
					readSdromNameSP(page_);
					setSoftLabel( Frame.SOFT_KEY_2 , "̕ҏW" );
					break;
				case 1 : // fromSP
					sploadRom();
					break;
				default :
					break;
			}
			repaint();
		}catch(Exception e){
			System.out.println("err selectMenuSpcach"+e.toString());	
		}
	}
	private void selectSpcache() {
		int romNo= selectSubMenuNo_;
		dialogNotReady = true;//߂ǂȂ̂ŁA_CAO̓ftH
		try{
			setMessage("ROMSP֕ۑ");
			String fnm = formatNumber((page_ - 1) * NUM_SDROM + romNo + 1, 3) + ".GB";
			SDbinding sd = new SDbinding();
			InputStream is = sd.openInputStream(fnm);
			byte romdata[] = new byte[1024*4096];
			int len = is.read(romdata) ;
			sd.close();
			is = null ;
			sd = null;
			System.gc();
			System.out.println((len/1024)+"KB");
			if(len > 524288){
				alert("ROMf[^傫܂!!");
				return;
			}else if(len < 65536){
				alert("ROMۑĂ܂!!");
				return;
			}
			DataOutputStream dis = Connector.openDataOutputStream("scratchpad:///0;pos=20000,length=" + (len + 4));
			dis.writeInt(len);
			dis.write(romdata,0,len);
			dis.flush();
			dis.close();
			infomsg("SP֕ۑ܂");
			repaint();
			SPmode = false;
			mode_ = MODE_MENU_SP_CACHE;
			selectSubMenuNo_ = 0;
			messageStr = "";
		}catch(Exception e){
			System.out.println("err selectMenuSpcach"+e.toString());	
		}
	}

	private void menuRomFile() {
		switch (selectSubMenuNo_) {
			case 0 : // SDt@C쐬
				if (sdPage_ < MAX_SDROM_PAGE) {
					if (confirm("SDJ[hɃt@C쐬܂H")) {
						sdPage_++;
						messageStr = "_~[t@C(y[W" + sdPage_ + ")쐬";
						repaint();
						createSdfiles(sdPage_);
						writeSP();
						messageStr = "";
					}
				} else {
					infomsg("őy[WɒB܂B");
				}
				break;
			case 1 : // SDt@C폜
				if (sdPage_ > 1) {
					if (confirm("SDJ[h̃t@C폜܂H\n납1y[W" + NUM_SDROM + "t@C폜")) {
						messageStr = "SDt@C(y[W" + sdPage_ + ")폜";
						repaint();
						deleteSdfiles(sdPage_);
						sdPage_--;
						if (sdNo_ > sdPage_ * NUM_SDROM) sdNo_ = 0;
						writeSP();
						messageStr = "";
					}
				} else {
					infomsg("ŏy[WɒB܂B");
				}
				break;
			case 2 : // ROMGNX|[g
				String eXstr = "";
				messageStr = "ROM̃GNX|[g";
				repaint();
				for(int i=0; i<sdPage_; i++){
					readSdromNameSP(i + 1);
					for(int j=0; j<NUM_SDROM; j++) eXstr = eXstr + subMenuRom[j].trim() + "\n";
				}
				imeOn(eXstr, TextBox.DISPLAY_ANY, TextBox.KANA);
				messageStr = "";
				break;
			case 3 : // ROMC|[g
				if (confirm("ROM̂C|[g܂H")) {
					imeOn("", TextBox.DISPLAY_ANY, TextBox.KANA);
				}
				break;
			case 4 : // 󂫗eʂ̊mF
				SDbinding sd = new SDbinding();
				long fs = sd.sdGetFreeSize() / 1024;
				infomsg("SDJ[h󂫗eʁF" + fs + "KB");
				break;
/*
			case 6 : // ROMLbV
				boolean svNoRomCache = noRomCache_;
				noRomCache_ = romcache.enableRomCache(noRomCache_);
				//core.set_spmode(!noRomCache_);
				if (noRomCache_) {
					if (svNoRomCache == noRomCache_) {
						alert("ROMLbV͖Ԃ̂߁AONɕύX邱Ƃ͂ł܂B");
					}
					dialogNotReady = true;
					if (confirm("SP̾ްSD\n߰܂H\n"
						+ "(SP̾ް͍폜܂)")) {
						bannerStr = "SP(XNb`pbh)ɕۑĂZ[uf[^SDɃRs[Ă܂B";
						romcache.onMoving = true;
						boolean ret = romcache.cache2sd(0);
						while(romcache.onMoving);
						infomsg("SPSDւ\n߰܂B"
							+ (ret ? "()" : "(s)"));
					}
				} else if (!noRomCache_ && (svNoRomCache != noRomCache_)) {
					dialogNotReady = true;
					if (confirm("SD̾ްSP\n߰܂H")) {
						bannerStr = "SDɕۑĂZ[uf[^SP(XNb`pbh)ɃRs[Ă܂B";
						romcache.onMoving = true;
						boolean ret = romcache.sd2cache(0);
						while(romcache.onMoving);
						infomsg("SDSPւ\n߰܂B"
							+ (ret ? "()" : "(s)"));
					}
				}
				writeSP();
				bannerActive = false; // oi[\{_CAO\ɕKv
				break;
			case 7 : // ROMLbVk[h
				compressMode_++;
				if (compressMode_ > 1) compressMode_ = -1;
				compressMode_ = romcache.setCompressMode(compressMode_);
				writeSP();
				break;
			case 8 : // ROMLbVk
				noCompress_ = romcache.disableCompress(!noCompress_);
				writeSP();
				break;
			case 9 : // ROMLbVœK
				romcache.compact();
				bannerActive = false; // oi[\{_CAO\ɕKv
				break;
			case 10 : // ROMLbV
				if (confirm("Nɏ܂B\nSPɕۑZ[uf[^Ȃǂׂ͂ď܂B\n낵łH"))
					romcache.reset();
				bannerActive = false; // oi[\{_CAO\ɕKv
				break;
			case 11 : // ROMLbV󂫗eʂ̊mF
				romcache.status();
				bannerActive = false; // oi[\{_CAO\ɕKv
				break;
*/
			default :
				break;
		}
		repaint();
	}

	private void menuRomInfo() {
		switch (selectSubMenuNo_) {
			case 2 : // MBC_MBC2
				gbcore.rtc_batt = !gbcore.rtc_batt;
				break;
			default :
				break;
		}
	}

	private void info_mbc_type() {
		switch (gbcore.mbc_type) {
			case 1 : // MBC_MBC1
				info_mbc = "MBC_MBC1";
				break;
			case 2 : // MBC_MBC2
				info_mbc = "MBC_MBC2";
				break;
			case 3 : // MBC_MBC3
				info_mbc = "MBC_MBC3";
				break;
			case 5 : // MBC_MBC5
				info_mbc = "MBC_MBC5";
				break;
			case 15 : // MBC_RUMBLE
				info_mbc = "MBC_RUMBLE";
				break;
			case 0xC1 : // MBC_HUC1
				info_mbc = "MBC_HUC1";
				break;
			case 0xC3 : // MBC_HUC3
				info_mbc = "MBC_HUC3";
				break;
			default :
				info_mbc = "unknownMBCtype";
				break;
		}
	}

	private void menuSelect(int i) {
		int j = -1;
		if (i == DOWN) j = 1;
		switch (mode_) {
			case MODE_MENU_ROOT:
				selectMenuNo_ = incNo(selectMenuNo_, j, subMenu.length);
				break;
			default :
				selectSubMenuNo_ = incNo(selectSubMenuNo_, j, subMenu.length);
				break;
		}
	}



	private void resumeGame() {
		mode_ = MODE_GAME;
		setSoftLabel( Frame.SOFT_KEY_1 , "MENU" );
		setRightSoftkeyLabel();
		displayClear = true;
		Display.setCurrent(this);
		new Thread(gbcore).start();
	}


	private void saveScreenShot() {
		Image ig;
		if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) != 0 && Anti_Alias_) {
			ig = Image.createImage(240, 216);
			(ig.getGraphics()).setRGBPixels(0, 0, 240, 216, fb, 0);
		} else if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) != 0) {
			ig = Image.createImage(240, 216);
			fb2G.setRGBPixels(0, 0, 160, 144, fb, 0);
			(ig.getGraphics()).drawScaledImage(fb2,0, 0, 240, 216, 0, 0, 160, 144);
		} else {	
			ig = Image.createImage(160, 144);
			(ig.getGraphics()).setRGBPixels(0, 0, 160, 144, fb, 0);
		}
		try {
			ImageEncoder ie = ImageEncoder.getEncoder("JPEG");
			ie.setAttribute(0, 0);
			EncodedImage ei;
			if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) != 0 && Anti_Alias_) {
				ei = ie.encode(ig, 0, 0, 240, 216);
			} else if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) != 0) {
				ei = ie.encode(ig, 0, 0, 240, 216);
			} else {
				ei = ie.encode(ig, 0, 0, 160, 144);
			}
			MediaImage mi = ei.getImage();
			mi.use();
			ImageStore.addEntry(mi);
			mi.unuse();
			mi.dispose();
		} catch(Exception e) {
			alert("Bes : " + e);
		}
	}

	private void sploadRom() {
			setMessage("ROMt@Cǂݍݒ");
		try {
			int romNo;
			int menuNo = 0;
			String fnm;
			DataInputStream dis = Connector.openDataInputStream("scratchpad:///0;pos=" + 20000 + ",length=4");
			int len = dis.readInt();
			dis.close();
			romInputStream = Connector.openDataInputStream("scratchpad:///0;pos=" + 20004 + ",length="+len);
			if (romInputStream.markSupported()) {
				romInputStream.mark(2);
				byte[] headPK = new byte[2];
				romInputStream.read(headPK);
				romInputStream.reset();
			}
			int c = gbcore.rom_load();
			if(c == 0) {
				chtTemp = false;
				chtTxt = "";
				chtTxt2 = "";
				for (int i = 0; i < NUM_CHEAT; i++) {
					chtType[i] = 0;
					chtVal[i] = 0;
					chtAdr[i] = 0;
					chtAdr2[i] =0;
				}
				rapidA = false;
				holdA = false;
				rapidB = false;
				holdB = false;
				gbcore.pad_set(0x10, false);
				gbcore.pad_set(0x20, false);
				romload = true;
				setSoftLabel( Frame.SOFT_KEY_1 , "MENU" );
				setRightSoftkeyLabel();
				System.gc();
				gbcore.emu_reset();
				resumeGame();
			} else if(c == -1) {
				alert("GBROMł͂܂");
				repaint();
				romInputStream.close();
				romInputStream = null;
				inputStream.close();
				inputStream = null;
				return;
			} else {
				romhisttemp.removeAllElements();
			}
		} catch(NullPointerException npe) {
			alert("ROMǂݍ߂܂");
			repaint();
		} finally {
			try {
				romInputStream.close();
				romInputStream = null;
				inputStream.close();
				inputStream = null;
				return;
			} catch(IOException ioe) {
				repaint();
				return;
			}
		}
	}

	private void loadRom (boolean notFirst) {
		SDbinding sd = new SDbinding();
		setMessage("ROMt@Cǂݍݒ");
		try {
			int romNo;
			int menuNo = 0;
			String fnm;
			if (notFirst) {
				romNo = selectSubMenuNo_;
			} else {
				romNo = lastRom;
			}
			fnm = formatNumber((page_ - 1) * NUM_SDROM + romNo + 1, 3) + ".GB";
			romInputStream = sd.openInputStream(fnm);
			if (romInputStream != null){
				if (romInputStream.markSupported()) {
					romInputStream.mark(2);
					byte[] headPK = new byte[2];
					romInputStream.read(headPK);
					romInputStream.reset();
				}
				int c = gbcore.rom_load();
				if(c == 0) {
					if (subMenuRom[romNo].equals(formatSpace(" ",32))) {
						subMenuRom[romNo] = gbcore.rom_name;
						saveRomName = gbcore.rom_name;
					} else {
						saveRomName = subMenuRom[romNo];
					}
					sd.close();
					romInputStream.close();
					romInputStream = null;
					inputStream.close();
					inputStream = null;
					chtTemp = false;
					chtTxt = "";
					chtTxt2 = "";
					for (int i = 0; i < NUM_CHEAT; i++) {
						chtType[i] = 0;
						chtVal[i] = 0;
						chtAdr[i] = 0;
						chtAdr2[i] =0;
					}
					rapidA = false;
					holdA = false;
					rapidB = false;
					holdB = false;
					gbcore.pad_set(0x10, false);
					gbcore.pad_set(0x20, false);
					romload = true;
					messageStr = "";
					setSoftLabel( Frame.SOFT_KEY_1 , "MENU" );
					setRightSoftkeyLabel();
					sdNo_ = (page_ - 1) * NUM_SDROM + selectSubMenuNo_;
					lastRom = romNo;
					writeSP();
					writeSdromNameSP((page_ - 1) * NUM_SDROM + romNo ,saveRomName);
					System.gc();
					gbcore.emu_reset();
					gbcore.loadRamFromSD();
					resumeGame();
				} else if(c == -1) {
					alert("GBROMł͂܂");
					sd.close();
					repaint();
					return;
				} else {
					romhisttemp.removeAllElements();
				}
			} else {
				if (confirm("ROMt@Cǂݍ߂܂B\n_~[t@Cč쐬܂H\n("
					+ sdPage_ + "y[W" + (sdPage_ * NUM_SDROM) + "t@C)")) {
					for (int i = 1; i <= sdPage_; i++) {
						messageStr = "_~[t@C(y[W" + i + ")쐬";
						repaint();
						createSdfiles(i);
					}
				}
				messageStr = "";
				repaint();
			}
		} catch(NullPointerException npe) {
			alert("err loadRom: "+ npe);
			sd.close();
			repaint();
			return;
		} catch(ArrayIndexOutOfBoundsException e) {
			repaint();
			return;
		} catch(IOException ioe) {
			repaint();
			return;
		}
	}



	public byte[] rom_page_load(String rom_name, int pageno) {
		try {
			byte[] buf = new byte[4096];
			int pos = 0;
			int rom_size = 0;
			if (pageno == 0) {
				if (inputStream != null) {
					inputStream.close();
				}
				inputStream = null;
			}
			if (inputStream == null) {
				inputStream = romInputStream;
			}
			while (pos < 4096) {
				int n = inputStream.read(buf, pos, 4096 - pos);
				if (n < 0) return null;
				pos += n;
				rom_size = buf.length * (pageno + 1) / 1024;
				if (rom_size < 10) setMessage("   " + rom_size + " LoCgǂݍ݂܂");
				else if (rom_size < 100) setMessage("  " + rom_size + " LoCgǂݍ݂܂");
				else if (rom_size < 1000) setMessage(" " + rom_size + " LoCgǂݍ݂܂");
				else if (rom_size < 10000) setMessage("" + rom_size + " LoCgǂݍ݂܂");
			}
			System.gc();
			return buf;
		} catch (IOException e) {
			return null;
		}
	}


	public byte[][] ram_load(String rom_name, int ramsize) {
		byte[][] b = new byte[ramsize * 2][4096];
		return b;
	}

	private void readSP() {
		try {
			DataInputStream is = Connector.openDataInputStream(
				"scratchpad:///0;pos=0,length=" + SIZE_SP_SETTING);
			for (int i = 0;i < 24;i++) {
				key[i] = is.readByte();
			}
			//NtO
			firstExec = is.readBoolean();
			//t[XLbv
			frameskip = is.readInt();
			fpsDisp_ = is.readInt();
			if (fpsDisp_ == 3) fpsOff_ = true;
			else fpsOff_ = false;
			//j[
			neuroSense = is.readInt();
			neuroWay = is.readBoolean();
			// Q[̃\tgL[\
			showSoftLabel_ = is.readBoolean();
			// ްђ̿ķ
			wt_on_game_ = is.readInt();
			if (wt_on_game_ < 0) wt_on_game_ = 0;
			else if (wt_on_game_ > 10000) wt_on_game_ = 10000;
			// `گ̳
			wt_on_refresh_ = is.readInt();
			if (wt_on_refresh_ < 0) wt_on_refresh_ = 0;
			else if (wt_on_refresh_ > 10000) wt_on_refresh_ = 10000;
			// QVGAʂłVGAtHgkĎg
			use_vgafont_ = is.readBoolean();
			//Pʃ[h
			reverseEnable_ = is.readBoolean();
			//F[V[h
			rotateEnable_ = is.readBoolean();
			// V_CAO
			dialogType_ = is.readInt() + 1;
			// `惂[h
			zoom_ = is.readInt();
			svZoom_ = is.readInt();
			//g\Aڂ邩ǂ
			Anti_Alias_ = is.readBoolean();

			pos_x[0] = is.readInt();
			pos_y[0] = is.readInt();
			//Nǂނǂ
			LoadRomFirst = is.readBoolean();
			lastRom = is.readInt();
			// ʉ]
			flipMode_ = is.readInt();
			// mFbZ[W
			confirmMsg_ = is.readInt();
			if ((confirmMsg_ & 0xC0) == 0) confirmMsg_ = 0xFE;
			// x(60FPS)
			sleep_ = is.readInt();
			// OSDROMԍ
			sdNo_ = is.readInt();
			// j[
			alpha = is.readBoolean();
			// SDt@Cy[W
			sdPage_ = is.readInt();
			if (sdPage_ == 0) sdPage_ = 1;
			// Eķ@\
			rSoftkey_ = is.readInt();
			// j[wiF
			menuBGcolor_ = is.readInt();
			// Q[ʐF
			gamecolor_ = is.readInt();

			/* TEh֘A */
			///PSG֘A///
			// TEhF
			cursound = is.readInt();
			// TEhʒl
			soundVolume_ = is.readInt();
			if (soundVolume_ < 10) soundVolume_ = 100;
			//TEhIIt
			soundEnable_ = is.readBoolean();
			//TEhobt@JEg
			soundBufCount_ = is.readInt();
			if (soundBufCount_ == 0) soundBufCount_ = 15;
			for(int i=0;i<4;i++) soundChEnable_[i] = is.readBoolean();
			for(int i=0;i<5;i++) soundToneNum_[i] = is.readInt();
			///PCM֘A///
			//o̓Tv[g
			soundSampleRate_ = is.readInt();
			//xlύX
			soundDelay_ = is.readInt();
			//TEhobt@JEg
			PCM_SoundBufCount_ = is.readInt();
			//PCMTEhChIIt
			for(int i=0;i<4;i++) PCM_soundChannelEnable_[i] = is.readBoolean();
			// Apuo̓tB^[h
			soundApuFilter = is.readInt();

			byte[] save = new byte[SIZE_STATE_NAME];
			for (int j = 0; j < NUM_STATE; j++) {
				is.read(save);
				if (save[0] == 0) {
					saveStr_[j] = "";
				} else {
					saveStr_[j] = new String(save);
				}
			}
			int keyClear = 0;
			for (int k = 0;k < 24;k++) keyClear += (int)key[k];
			if (keyClear < 1) {
				key = new int[] {17,19,16,18,20,22,24, 2,11, 0,63,63,
								  1, 4, 7,10, 5, 6, 3, 8, 9,63,63,63};
			}
			/////////////////////////////
			// ftHglݒ
			/////////////////////////////
			if (frameskip == 0) frameskip = FS_default;
			// W`Ch̏ʒu
			// t[̏TCY
			if (pos_x[0] < 0) pos_x[0] = 100;
			if (pos_y[0] < 0) pos_y[0] = 100;
			pos_x[1] = (pos_x[0] >> 16) & 0xFFFF;
			pos_y[1] = (pos_y[0] >> 16) & 0xFFFF;
			pos_x[0] &= 0xFFFF;
			pos_y[0] &= 0xFFFF;

			is.close();
			is = null;
		} catch(IOException e) {
			alert("loadConfig:"+ e.toString());
		}
	}

	private void readSdromNameSP(final int page) {
		DataInputStream is = null;
		
		try {
			is = Connector.openDataInputStream(
					"scratchpad:///0;pos="
						+ (SIZE_SP_SETTING + (SIZE_ROM_NAME * NUM_SDROM) * (page - 1))
						+ ",length=" + SIZE_ROM_NAME * NUM_SDROM);
			byte[] name = new byte[SIZE_ROM_NAME];
			for (int i = 0; i < NUM_SDROM; i++) {
				is.read(name);
				if (name[0] == 0) {
					subMenuRom[i] = formatSpace(" ",32);
				} else {
					subMenuRom[i] = new String(name);
				}
			}
		} catch (Exception e) {
		    alert("err readSdromNameSP: " + e);
		} finally {
			try {
				is.close();
				is = null;
			} catch (Exception ex) {
				is = null;
			}
		}
	}

	private void writeSdromNameSP(final int sdno, final String romnm) {
		DataOutputStream os = null;
		try {
			os = Connector.openDataOutputStream(
					"scratchpad:///0;pos="
						+ (SIZE_SP_SETTING + SIZE_ROM_NAME * sdno)
						+ ",length=" + SIZE_ROM_NAME);
			os.write(formatSpace(romnm, SIZE_ROM_NAME).getBytes());
			os.flush();
		} catch (Exception e) {
			alert("err writeSdromNameSP: " + e);
		} finally {
			try {
				os.close();
				os = null;
			} catch (Exception ex) {
				os = null;
			}
		}
	}

	private void writeSP() {
		try {
			DataOutputStream os = Connector.openDataOutputStream(
				"scratchpad:///0;pos=0,length=" + SIZE_SP_SETTING);
			for (int i = 0;i < 24;i++) {
				os.writeByte(key[i]);
			}
			//NtO
			os.writeBoolean(firstExec);
			//t[XLbv
			os.writeInt(frameskip);
			os.writeInt(fpsDisp_);
			//j[
			os.writeInt(neuroSense);
			os.writeBoolean(neuroWay);
			// Q[̃\tgL[\
			os.writeBoolean(showSoftLabel_);
			// ްђ̿ķ
			os.writeInt(wt_on_game_);
			// `گ̳
			os.writeInt(wt_on_refresh_);
			// QVGAʂłVGAtHgkĎg
			os.writeBoolean(use_vgafont_);
			//Pʃ[h
			os.writeBoolean(reverseEnable_);
			//F[V[h
			os.writeBoolean(rotateEnable_);
			// V_CAO(1Zۑ
			os.writeInt(dialogType_ - 1);
			//Y[
			os.writeInt(zoom_);
			os.writeInt(svZoom_);
			//g\Aڂ邩ǂ
			os.writeBoolean(Anti_Alias_);
			//gp -> 0A{ 0 -> -1BӖȂEEE
			int pos_x3, pos_y3;
			if (svPos_x4 != 0)
				pos_x3 = (svPos_x4 << 16) | (pos_x[0] & 0xFFFF);
			else
				pos_x3 = (pos_x[1] << 16) | (pos_x[0] & 0xFFFF);
			if (svPos_y4 != 0)
				pos_y3 = (svPos_y4 << 16) | (pos_y[0] & 0xFFFF);
			else
				pos_y3 = (pos_y[1] << 16) | (pos_y[0] & 0xFFFF);
			if (pos_x3 == 100) os.writeInt(-1);
			else os.writeInt(pos_x3);
			if (pos_y3 == 100) os.writeInt(-1);
			else os.writeInt(pos_y3);

			//Nǂݍނǂ
			os.writeBoolean(LoadRomFirst);
			os.writeInt(lastRom);
			// ʉ]
			os.writeInt(flipMode_);
			// mFbZ[W
			os.writeInt(confirmMsg_);
			// x(60FPS)F4byte
			os.writeInt(sleep_);
			// OSDROMԍ
			os.writeInt(sdNo_);
			// j[
			os.writeBoolean(alpha);
			// SDt@Cy[W
			os.writeInt(sdPage_);
			// Eķ@\F4byte
			os.writeInt(rSoftkey_);
			// j[wiF
			os.writeInt(menuBGcolor_);
			// Q[ʐF
			os.writeInt(gamecolor_);

			/* TEh֘A */
			// TEhF
			os.writeInt(cursound);
			// TEhʒl
			os.writeInt(soundVolume_);
			//TEhIIt
			os.writeBoolean(soundEnable_);
			//TEhobt@JEg
			os.writeInt(soundBufCount_);
			for(int i=0;i<4;i++) os.writeBoolean(soundChEnable_[i]);
			for(int i=0;i<5;i++) os.writeInt(soundToneNum_[i]);
			//o̓Tv[g
			os.writeInt(soundSampleRate_);
			//xlύX
			os.writeInt(soundDelay_);
			//TEhobt@JEg
			os.writeInt(PCM_SoundBufCount_);
			//PCMTEhChIIt
			for(int i=0;i<4;i++) os.writeBoolean(PCM_soundChannelEnable_[i]);
			// Apuo̓tB^[h
			os.writeInt(soundApuFilter);

			for (int j = 0; j < NUM_STATE; j++) {
				byte[] data = formatSpace(saveStr_[j], SIZE_STATE_NAME).getBytes();
				os.write(data);
			}
			os.close();
			os = null;
		} catch (IOException ioe) {
		}
	}

	private void loadState(int slot) {
		SDbinding sd = null;
		DataInputStream dis = null;
		try {
			sd = new SDbinding();
			dis = sd.openDataInputStream(getSaveFile(slot));
			if (dis != null){
			    gbcore.loadState(dis,palette,0x25800L);
			}
//		} catch (IOException e) {
		} finally {
			sd.close();
			dis = null;
			sd = null;
		}
		//SDbinding.closeFileEntry();
	}

	private void saveState(int slot) {
		SDbinding sd = null;
		DataOutputStream dos = null;
		try {
			sd = new SDbinding();
			dos = sd.openDataOutputStream(getSaveFile(slot));
			if (dos != null){
				gbcore.saveState(dos,palette);
				dos.flush();
			}
		} catch (IOException e) {
		} finally {
			sd.close();
			dos = null;
			sd = null;
		}
		//SDbinding.closeFileEntry();
	}

	private void loadCheat() {
		SDbinding sd = new SDbinding();
		DataInputStream dis = sd.openDataInputStream(gbcore.rom_name_sd + ".cht");
		try {
			int len = dis.readInt();
			byte[] buf = new byte[len];
			dis.read(buf);
			chtTxt = new String(buf);
			for (int i = 0; i < NUM_CHEAT; i++) {
				chtType[i] = dis.readInt();
				chtVal[i] =  dis.readInt();
				chtAdr[i] =  dis.readInt();
				chtAdr2[i] = dis.readInt();
			}
		} catch (IOException ioe) {
		} catch (NullPointerException npe){
			alert("`[gR[hL܂!");
		} finally {
			try {
				dis.close();
				dis = null;
				sd.close();
			} catch (IOException ioe) {
			} catch (NullPointerException npe){
			}
		}
	}



	private void saveCheat() {
		SDbinding sd = new SDbinding();
		DataOutputStream dos = sd.openDataOutputStream(gbcore.rom_name_sd + ".cht");
		try {
			byte[] buf = chtTxt.getBytes();
			dos.writeInt(buf.length);
			dos.write(buf);
			for (int i = 0; i < NUM_CHEAT; i++) {
				dos.writeInt(chtType[i]);
				dos.writeInt(chtVal[i]);
				dos.writeInt(chtAdr[i]);
				dos.writeInt(chtAdr2[i]);
			}
		} catch (IOException ioe) {
		} catch (NullPointerException npe){
		} finally {
			try {
				dos.close();
				dos = null;
				sd.close();
			} catch (IOException ioe) {
			} catch (NullPointerException npe){
			}
		}
	}

	private boolean isReverse() {
		boolean rt;
		if (reverseEnable_) {
			try {
				switch(PhoneSystem.getAttribute(PhoneSystem2.DEV_DISPLAY_STYLE)){
					case PhoneSystem2.ATTR_DISPLAY_STYLE_REVERSE :
						//P905J
						rt = true;
						break;
					default :
						rt = false;
				}
			} catch (Exception ex) {
				rt = false;
			}
		} else {
			rt = false;
		}
		return rt;
	}

	private int isRotate() {
		int rt = -1;
		if (rotateEnable_) {
			try {
				switch(PhoneSystem.getAttribute(PhoneSystem2.DEV_DISPLAY_STYLE)){
					case PhoneSystem2.ATTR_DISPLAY_STYLE_HORIZONTAL_LEFT :
						//Fxxx|
						rt = 1;
						break;
					case PhoneSystem2.ATTR_DISPLAY_STYLE_HORIZONTAL_RIGHT :
						//FxxxE|
						rt = 2;
						break;
					default :
						rt = 0;
				}
			} catch (Exception ex) {
				rt = -1;
			}
		} else {
			rt = -1;
		}
		return rt;
	}

	private void setFlipModeKey() {
		boolean rev = false;
		int tmp;
		if (rotateEnable_) {
			if (widedisplay_) {
				switch (flipMode_) {
					case 0 : //ʏ
						switch (isRotate()) {
							case 0 : //ʏ
								flipModeKey_ = 2;
								break;
							case 1 : //
							case 2 : //E
								flipModeKey_ = 1;
								break;
							default :
								flipModeKey_ = 0;
								break;
						}
						break;
					case 1 : //E
						switch (isRotate()) {
							case 0 : //ʏ
								flipModeKey_ = 3;
								break;
							case 1 : //
							case 2 : //E
								flipModeKey_ = 2;
								break;
							default :
								flipModeKey_ = 1;
								break;
						}
						break;
					case 2 : //180
						switch (isRotate()) {
							case 0 : //ʏ
								flipModeKey_ = 0;
								break;
							case 1 : //
							case 2 : //E
								flipModeKey_ = 3;
								break;
							default :
								flipModeKey_ = 2;
								break;
						}
						break;
					case 3 : //
						switch (isRotate()) {
							case 0 : //ʏ
								flipModeKey_ = 1;
								break;
							case 1 : //
							case 2 : //E
								flipModeKey_ = 0;
								break;
							default :
								flipModeKey_ = 3;
								break;
						}
						break;
					default :
						flipModeKey_ = 0;
						break;
				}
			} else {
				switch (flipMode_) {
					case 0 : //ʏ
						switch (isRotate()) {
							case 0 : //ʏ
								flipModeKey_ = 0;
								break;
							case 1 : //
								flipModeKey_ = 1;
								break;
							case 2 : //E
								flipModeKey_ = 3;
								break;
						}
						break;
					case 1 : //E
						switch (isRotate()) {
							case 0 : //ʏ
								flipModeKey_ = 1;
								break;
							case 1 : //
								flipModeKey_ = 2;
								break;
							case 2 : //E
								flipModeKey_ = 0;
								break;
						}
						break;
					case 2 : //180
						switch (isRotate()) {
							case 0 : //ʏ
								flipModeKey_ = 2;
								break;
							case 1 : //
								flipModeKey_ = 3;
								break;
							case 2 : //E
								flipModeKey_ = 1;
								break;
						}
						break;
					case 3 : //
						switch (isRotate()) {
							case 0 : //ʏ
								flipModeKey_ = 3;
								break;
							case 1 : //
								flipModeKey_ = 0;
								break;
							case 2 : //E
								flipModeKey_ = 2;
								break;
						}
						break;
					default :
						flipModeKey_ = 0;
						break;
				}
			}
		} else {
			rev = isReverse();
			switch (flipMode_) {
				case 0 : //ʏ
					flipModeKey_ = rev ? 1 : 0;
					break;
				case 1 : //E
					flipModeKey_ = rev ? 2 : 1;
					break;
				case 2 : //180
					flipModeKey_ = rev ? 3 : 2;
					break;
				case 3 : //
					flipModeKey_ = rev ? 0 : 3;
					break;
				default :
					flipModeKey_ = 0;
					break;
			}
		}
		switch (flipModeKey_) {
			//ʎ
			case 1 :
			case 3 :
				if (widedisplay_) {
					width = getWidth();
					height = getHeight();
				} else {
					width = getHeight();
					height = getWidth();
				}
				break;
			case 0 :
			case 2 :
				if (widedisplay_) {
					width = getHeight();
					height = getWidth();
				} else {
					width = getWidth();
					height = getHeight();
				}
				break;
		}
		setflipPad();
	}

	private void refreshDisplay() {
		try {
			Thread.sleep((long)wt_on_refresh_);
		} catch (Exception ex) {}
		setBackground(Graphics.getColorOfName(Graphics.BLACK));
		int modesave = mode_;
		mode_ = MODE_NONE;
		g.setFlipMode(Graphics.FLIP_NONE);
		g.clearRect(0, 0, getWidth(), getHeight());
		repaint();
		mode_ = modesave;
	}


	private void usePointerGame() {
		try {
			PointingDevice.isAvailable();
			int x = PointingDevice.getDirectionX();
			int y = PointingDevice.getDirectionY();
			int z = PointingDevice.getDirectionZ();
			int p = neuroSense;
			if (neuroWay) {
				if(x > p && z > 1) {gbcore.pad_set(pad[3], true);neuroRight = 1;}
				if(x < (-1 * p) && z > 1) {gbcore.pad_set(pad[2], true);neuroLeft = 1;}
				if(y > p && z > 1) {gbcore.pad_set(pad[1], true);neuroDown = 1;}
				if(y < (-1 * p) && z > 1) {gbcore.pad_set(pad[0], true);neuroUp = 1;}
				if(x < p && neuroRight == 1) {gbcore.pad_set(pad[3], false);neuroRight = 0;}
				if(x > (-1 * p) && neuroLeft == 1) {gbcore.pad_set(pad[2], false);neuroLeft = 0;}
				if(y < p && neuroDown == 1) {gbcore.pad_set(pad[1], false);neuroDown = 0;}
				if(y > (-1 * p) && neuroUp == 1) {gbcore.pad_set(pad[0], false);neuroUp = 0;}
			} else {
				if (neuroUp == 0 && neuroDown == 0) {
					if(x > p && z > 1) {gbcore.pad_set(pad[3], true);neuroRight = 1;}
					if(x < (-1 * p) && z > 1) {gbcore.pad_set(pad[2], true);neuroLeft = 1;}
				}
				if (neuroRight == 0 && neuroLeft == 0) {
					if(y > p && z > 1) {gbcore.pad_set(pad[1], true);neuroDown = 1;}
					if(y < (-1 * p) && z > 1) {gbcore.pad_set(pad[0], true);neuroUp = 1;}
				}
				if(x < p && neuroRight == 1) {gbcore.pad_set(pad[3], false);neuroRight = 0;}
				if(x > (-1 * p) && neuroLeft == 1) {gbcore.pad_set(pad[2], false);neuroLeft = 0;}
				if(y < p && neuroDown == 1) {gbcore.pad_set(pad[1], false);neuroDown = 0;}
				if(y > (-1 * p) && neuroUp == 1) {gbcore.pad_set(pad[0], false);neuroUp = 0;}
			}
		} catch (Exception e) {
		}
	}


	private void createSdfiles(final int page) {
		//_~[SDt@C쐬
		int j = (page - 1) * NUM_SDROM + 1;
		SDbinding sd = new SDbinding();
		for(int i = j; i < j + NUM_SDROM; i++){
			sd.createFile(formatNumber(i, 3) + ".GB");
		}
	}

	private void deleteSdfiles(final int page) {
		//_~[SDt@C폜
		int j = (page - 1) * NUM_SDROM + 1;
		SDbinding sd = new SDbinding();
		for(int i = j; i < j + NUM_SDROM; i++){
			sd.deleteFile(formatNumber(i, 3) + ".GB");
			writeSdromNameSP(i - 1, "");
		}
	}

	private void writeSaveDate() {
		Calendar cal = Calendar.getInstance();
		if (importImage) saveRomName = "ImportSaveData";
		saveStr_[selectSubMenuNo_] = formatSpace(
			formatNumber(cal.get(Calendar.MONTH) + 1, 2)
				+ "/"
				+ formatNumber(cal.get(Calendar.DATE), 2)
				+ " "
				+ formatNumber(cal.get(Calendar.HOUR_OF_DAY), 2)
				+ ":"
				+ formatNumber(cal.get(Calendar.MINUTE), 2)
				+ " "
				+ saveRomName, SIZE_STATE_NAME);
		writeSP();
		importImage = false;
	}



	private void exportGIF(int slot) {
		final byte[] GIF_FOOTER = { 0x00, 0x3B };
		SDbinding sd = null;
		DataInputStream in = null;
		try {
			byte[] inData = new byte[SIZE_STATE];
			sd = new SDbinding();
			in = sd.openDataInputStream(getSaveFile(slot));
			if (in == null) {
				alert("t@CǍ݂Ɏs܂B");
				return;
			}
			in.read(inData);
			int blocksSize = inData.length / EXPORT_BLOCK_SIZE;
			int lastBlockLength = inData.length % EXPORT_BLOCK_SIZE;
			boolean lastBlockExists = false;
			if (lastBlockLength != 0) {
				lastBlockExists = true;
			}
			int lastCnt = 0;
			if (lastBlockExists) {
				lastCnt = 1;
			}
			byte[] outData =
				new byte[GIF_HEADER.length
					+ inData.length
					+ blocksSize
					+ lastCnt
					+ GIF_FOOTER.length];
			System.arraycopy(GIF_HEADER, 0, outData, 0, GIF_HEADER.length);
			int outCnt = GIF_HEADER.length;
			int inCnt = 0;
			for (int i = 0; i < blocksSize; i++) {
				outData[outCnt] = EXPORT_BLOCK_SIZE - 0x100;
				outCnt++;
				System.arraycopy(
					inData,
					inCnt,
					outData,
					outCnt,
					EXPORT_BLOCK_SIZE);
				outCnt += EXPORT_BLOCK_SIZE;
				inCnt += EXPORT_BLOCK_SIZE;
			}
			if (lastBlockExists) {
				outData[outCnt] = (byte) lastBlockLength;
				outCnt++;

				System.arraycopy(
					inData,
					inCnt,
					outData,
					outCnt,
					lastBlockLength);
				outCnt += lastBlockLength;
				inCnt += lastBlockLength;
			}
			System.arraycopy(GIF_FOOTER, 0, outData, outCnt, GIF_FOOTER.length);
			MediaImage mediaImage = MediaManager.getImage(outData);
			mediaImage.use();
			ImageStore.addEntry(mediaImage);
			mediaImage.unuse();
			mediaImage.dispose();
		} catch (Exception e) {
			alert("err exportGIF: " + e);
		} finally {
			sd.close();
			in = null;
			sd = null;
		}
		repaint();
	}



	private void importGIF(int slot) {
		SDbinding sd = null;
		InputStream is = null;
		DataOutputStream out = null;
		try {
			ImageStore istore = ImageStore.selectEntry();
			if (istore == null) {
				return;
			}
			is = istore.getInputStream();
			byte[] header = new byte[6];
			is.read(header);
			if (new String(header).equals("GIF89a")) {
				is.skip(GIF_HEADER.length - 6);
				int length = is.available();
				byte[] importData = new byte[SIZE_STATE];
				int importedSize = 0;
				boolean last = false;
				while (!last) {
					int size = is.read();
					if (size != EXPORT_BLOCK_SIZE) {
						last = true;
					}
					byte[] block = new byte[size];
					is.read(block);
					if (importedSize + size > importData.length) {
						alert("length is over:" + length);
						return;
					}
					System.arraycopy(block, 0, importData, importedSize, size);
					importedSize += size;
				}
				sd = new SDbinding();
				out = sd.openDataOutputStream(getSaveFile(slot));
				if (out == null) {
					alert("t@C݂Ɏs܂B");
				}
				out.write(importData, 0, importData.length);
				out.flush();

				importImage = true;
				writeSaveDate();

			} else {
				alert("not GIF");
				return;
			}
		} catch (Exception e) {
			alert("err importGIF: " + e);
		} finally {
			try {
				is.close();
				is = null;
				sd.close();
				out = null;
				sd = null;
			} catch (Exception ex) {
				is = null;
				out = null;
				sd = null;
			}
		}
		repaint();
	}



	private String formatSpace(final String str, final int size) {
		String ret;
		byte[] inbyte = str.getBytes();
		if (inbyte.length > size) {
			ret = new String(inbyte, 0, size); 
		} else {
			ret = str;
		}
		while (ret.getBytes().length < size) {
			ret = ret.concat(" ");
		}
		return ret;
	}



	private String formatNumber(final int num, final int size) {
		String str = String.valueOf(num);
		while (str.length() < size) {
			str = "0" + str;
		}
		return str;
	}



	// _CAOp̃{^
	private void dialogButton(String s, int x, int y, boolean select, boolean press) {
		Graphics g = menuG;
		int rx = 6*scale;
		int ry = 7*scale;
		int w = 40*scale;
		rx = 3*scale;
		ry = 6*scale;

		//Og
		int d=2*scale;
		if (select) {
			g.setColor(g.getColorOfRGB(180,60,60));
		} else if (press) {
			if (dialogType_ == 2) {
				g.setColor(g.getColorOfRGB(60,60,60));
			} else {
				g.setColor(g.getColorOfRGB(180,180,180));
			}
		} else {
			g.setColor(g.getColorOfRGB(120,120,120));
		}
		g.fillArc(x-d, y-d, (rx+d)*2, (ry+d)*2, 90, 180);
		g.fillRect(x + rx, y-d, w, (ry+d)*2);
		g.fillArc(x-d + w, y-d, (rx+d)*2, (ry+d)*2, 270, 180);
    
		//g㔼
		if (dialogType_ == 2) {
			if (press) {
				g.setColor(g.getColorOfRGB(60,60,60));
			} else {
				g.setColor(g.getColorOfRGB(90,90,90));
			}
		} else {
			if (press) {
				g.setColor(g.getColorOfRGB(180,180,180));
			} else {
				g.setColor(g.getColorOfRGB(210,210,210));
			}
		}
		g.fillArc(x, y, rx*2, ry*2, 90, 90);
		g.fillRect(x + rx, y, w, ry);
		g.fillArc(x + w, y, rx*2, ry*2, 0, 90);
    
		//g
		if (dialogType_ == 2) {
			if (press) {
				g.setColor(g.getColorOfRGB(90,90,90));
			} else {
				g.setColor(g.getColorOfRGB(60,60,60));
			}
		} else {
			if (press) {
				g.setColor(g.getColorOfRGB(210,210,210));
			} else {
				g.setColor(g.getColorOfRGB(180,180,180));
			}
		}
		g.fillArc(x, y, rx*2, ry*2, 180, 90);
		g.fillRect(x + rx, y+ry, w, ry);
		g.fillArc(x + w, y, rx*2, ry*2, 270, 90);
    
		//
		if (dialogType_ == 2) {
			//炵ĉet
			g.setColor(g.getColorOfRGB(60,60,60));
			g.drawString(s,
			x + rx + (w - MENU_DEFAULT_FONT.stringWidth(s))/2 + 1*scale,
			y + DIALOG_BASE_LINE - 1*scale);
			g.setColor(Graphics.getColorOfName(Graphics.WHITE));
		} else {
			g.setColor(g.getColorOfRGB(60,60,60));
		}
		g.drawString(s,
                x + rx + (w - MENU_DEFAULT_FONT.stringWidth(s))/2,
                y + DIALOG_BASE_LINE - 1*scale);
	}

	private void myDialog(String msg, String title, int titlecolor, String button1, String button2, int maxWidth) {
		Graphics g = menuG;
		int i;

		// EBhEŏ
		int mw;
		if (button2 != "") {
			mw = 150*scale;
		} else {
			mw = 120*scale;
		}
		// {^
		int bw = 46*scale;
        
		// EBhE
		int w = maxWidth - 8*scale*2;
        
		//1sPʂɕbZ[W
		String[] ns = splitString(msg, "\n", w - 8*scale*2);
		// ߂
		int dm = 0;
		w = 0;
		for (i = 0; i < ns.length; i++) {
			int tmp = MENU_DEFAULT_FONT.stringWidth(ns[i]) + 2*8*scale;
			if (w < tmp) w = tmp;
		}
		if (w < mw) {
			dm = (mw - w) / 2;
			w = mw;
		}
        
		// EBhEAʒu
		int h = DIALOG_HEIGHT_LINE * (1 + ns.length + 2) + 8*scale;
		int x = (maxWidth - w) / 2;
		int y = (MENU_HEIGHT - h) / 2;

        
		// Og̃hbgʒu(CRp)
		int[] x1={x,x+2,x+w-2,x+w,x+w,x+w-2,x+2,x,x};
		int[] y1={y+2,y,y,y+2,y+h-2,y+h,y+h,y+h-2,y+2};
		int[] x2={x-1,x+2,x+w-2,x+w+1,x+w+1,x+w-2,x+2,x-1,x-1};
		int[] y2={y+2,y-1,y-1,y+2,y+h-2,y+h+1,y+h+1,y+h-2,y+2};

		// ߐF΍Ń{^ȊO͂Px`悵Ȃ
		if (!dialogShowed) {
			//lp
			g.setColor(titlecolor);
			g.fillRect(x, y, w, DIALOG_HEIGHT_LINE + 2*scale);
			if (dialogType_ == 2) {
				//ÂFœhԂ
				g.setColor(Graphics.getColorOfRGB(0,0,0,0x80));
				g.fillRect(x + 1*scale, y + 1*scale, w - 2*scale, DIALOG_HEIGHT_LINE + 1*scale);
			}

			//^Cg
			if (dialogType_ == 2) {
				//炵ĉet
				g.setColor(Graphics.getColorOfName(Graphics.BLACK));
				g.drawString(title,
					x + (w - MENU_DEFAULT_FONT.stringWidth(title))/2 + 1*scale,
					y + DIALOG_BASE_LINE + 1*scale);
				g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			} else {
				g.setColor(Graphics.getColorOfName(Graphics.BLACK));
			}
			g.drawString(title,
			x + (w - MENU_DEFAULT_FONT.stringWidth(title))/2,
				y + DIALOG_BASE_LINE + 1*scale);

			//lp
			g.setColor(g.getColorOfRGB(255,255,255,0xE8));
			g.fillRect(x, y + DIALOG_HEIGHT_LINE + 2*scale, w, h - DIALOG_HEIGHT_LINE - 2*scale);
			if (dialogType_ == 2) {
				//ÂFœhԂ
				g.setColor(g.getColorOfRGB(0x20,0x20,0x40,0xD0));
				g.fillRect(x + 1*scale,
					y + DIALOG_HEIGHT_LINE + 3*scale,
						w - 2*scale,
						h - DIALOG_HEIGHT_LINE - 4*scale);
			}

			//g1
			g.setColor(g.getColorOfRGB(0x88,0x88,0x88));
			g.drawPolyline(x1, y1, 9);

			//g2
			g.setColor(g.getColorOfRGB(0,0,0));
			g.drawPolyline(x2, y2, 9);

			//{
			if (dialogType_ == 2) {
				//炵ĉet
				g.setColor(Graphics.getColorOfName(Graphics.BLACK));
				for (i = 0; i < ns.length; i++) {
					g.drawString(ns[i],
					x + 8*scale + dm + 1*scale,
						y + DIALOG_HEIGHT_LINE*(i+1) + DIALOG_BASE_LINE + 5*scale);
				}
				g.setColor(Graphics.getColorOfName(Graphics.WHITE));
			} else {
				g.setColor(Graphics.getColorOfName(Graphics.BLACK));
			}
			for (i = 0; i < ns.length; i++) {
				g.drawString(ns[i],
				x + 8*scale + dm,
					y + DIALOG_HEIGHT_LINE*(i+1) + DIALOG_BASE_LINE + 5*scale);
			}
		}

		//{^\
		if (button2 != "") {
			// Q{^
			dialogButton(button1,
				x + (w-(bw+10*scale+bw))/2,
				y + DIALOG_HEIGHT_LINE*(i+1) + 14*scale,
				dialogYes,
				dialogYes && dialogPressed);
			dialogButton(button2,
				x + (w-(bw+10*scale+bw))/2 + 10*scale + bw,
				y + DIALOG_HEIGHT_LINE*(i+1) + 14*scale,
				!dialogYes,
				!dialogYes && dialogPressed);
		} else {
			// P{^
			dialogButton(button1,
				x + (w-bw)/2,
				y + DIALOG_HEIGHT_LINE*(i+1) + 14*scale,
				false,
				dialogPressed);
		}
	}


	public void alert(final String s) {
		while (getKeypadState() != 0){
			try {
				Thread.sleep(10L);
			} catch (Exception ex) {}
		}
		if (dialogNotReady || dialogType_ == 0 || mode_ == MODE_GAME) {
			Dialog dialog = new Dialog(Dialog.DIALOG_ERROR, "G[I");
			dialog.setText(s);
			dialog.show();
			messageStr = "";
			refreshDisplay();
		} else {
			if (!dialogReleased) {
				svMode = mode_;
				mode_ = MODE_DIALOG;
				dialogMode = Dialog.DIALOG_ERROR;
				dialogMessage = s;
				repaint();
			} else {
				// ɂ͓BȂ͂
				dialogReleased = false;
				dialogShowed = false;
				messageStr = "";
				refreshDisplay();
			}
		}
	}

	public void infomsg(final String s) {
		while (getKeypadState() != 0){
			try {
				Thread.sleep(10L);
			} catch (Exception ex) {}
		}
		if (dialogNotReady || dialogType_ == 0 || mode_ == MODE_GAME) {
			Dialog dialog = new Dialog(Dialog.DIALOG_INFO , "");
			dialog.setText(s);
			dialog.show();
			refreshDisplay();
		} else {
			if (!dialogReleased) {
				svMode = mode_;
				mode_ = MODE_DIALOG;
				dialogMode = Dialog.DIALOG_INFO;
				dialogMessage = s;
				repaint();
			} else {
				// ɂ͓BȂ͂
				dialogReleased = false;
				dialogShowed = false;
				refreshDisplay();
			}
		}
	}

	public boolean confirm(final String s) {
		while (getKeypadState() != 0){
			try {
				Thread.sleep(10L);
			} catch (Exception ex) {}
		}
		boolean ret;
		if (dialogNotReady || dialogType_ == 0 || mode_ == MODE_GAME) {
			Dialog dialog = new Dialog(Dialog.DIALOG_YESNO, "mF");
			dialog.setText(s);
			ret = (dialog.show() == Dialog.BUTTON_YES);
			refreshDisplay();
		} else {
			if (!dialogReleased) {
				svMode = mode_;
				mode_ = MODE_DIALOG;
				dialogMode = Dialog.DIALOG_YESNO;
				dialogYes = true;
				dialogMessage = s;
				repaint();
				ret = false;
			} else {
				dialogReleased = false;
				dialogShowed = false;
				ret = dialogYes;
				refreshDisplay();
			}
		}
		return ret;
	}



	private int incNo(int no, final int add, final int max) {
		no += add;
		if (no < 0) {
			no += max;
		}
		no %= max;
		return no;
	}



	private String[] split(String fromstr, char sptc){
		int idx1 = 0 , idx2 = 0, i;
		String[] splt = new String[NUM_SDROM * MAX_SDROM_PAGE];
		for(i=0; idx2<fromstr.length() - 1; i++){
			if (i > NUM_SDROM * MAX_SDROM_PAGE) break;
			idx2 = fromstr.indexOf(sptc, idx1);
			if(idx2 == -1) idx2 = fromstr.length() - 1;
			splt[i] = fromstr.substring(idx1, idx2);
			idx1 = idx2+1;
		}
		String[] re = new String[i];
		for(int j=0; j<re.length; j++) re[j] = splt[j];
		return re;
	}

	//  s  c ؂Ƃ w Ɏ܂Pʂɕĕԋp
	// tHgTCY MENU_DEFAULT_FONT gp
	//  []s ̐擪 c ̎͐@\Ȃ
	private String[] splitString(String s, String c, int w) {
		int start = 0;
		int end = 1;
		int length = s.length();
		int line = 0;
		while (end <= length) {
			if (c != "" && s.startsWith(c, end - 1)) {
				start = end;
				end = start + 1;
				line++;
			} else if (w > 0 && MENU_DEFAULT_FONT.stringWidth(s.substring(start, end)) > w) {
				start = end - 1;
				end = start + 1;
				line++;
			} else {
				end++;
			}
		}
		if (s.substring(start, end - 1).length() > 0) {
			line++;
		}

		String[] ss = new String[line];
		start = 0;
		end = 1;
		line = 0;
		while (end <= length) {
			if (c != "" && s.startsWith(c, end - 1)) {
				ss[line] = s.substring(start, end - 1);
				start = end;
				end = start + 1;
				line++;
			} else if (w > 0 && MENU_DEFAULT_FONT.stringWidth(s.substring(start, end)) > w) {
				ss[line] = s.substring(start, end - 1);
				start = end - 1;
				end = start + 1;
				line++;
			} else {
				end++;
			}
		}
		if (s.substring(start, end - 1).length() > 0) {
			ss[line] = s.substring(start, end - 1);
		}
		return ss;
	}


	public void drawLine(byte[] linebuf, int scx, int raster) {
		if (raster < 0 || raster >= 144) return;
		final int[] fb = this.fb;
		final int[] palette = this.palette;
		if (((flipModeKey_==1 || flipModeKey_== 3) ? svZoom_ : zoom_) != 0 && Anti_Alias_) {
			int j = (raster >> 1) * 720;
			if ((raster & 1) == 0) {
				for (int i = 0; i < 160; i += 2) {
					int c1 = palette[linebuf[scx + i]];
					int c2 = palette[linebuf[scx + i + 1]];
					fb[j] = c1;
					fb[j + 1] = (c1 + c2) >> 1;
					fb[j + 2] = c2;
					j += 3;
				}
			} else {
				for (int i = 0; i < 160; i += 2) {
					int c1 = palette[linebuf[scx + i]];
					int c2 = palette[linebuf[scx + i + 1]];
					fb[j + 480] = c1;
					fb[j + 481] = (c1 + c2) >> 1;
					fb[j + 482] = c2;
					fb[j + 240] = (fb[j] + c1) >> 1;
					fb[j + 241] = (fb[j] + c2) >> 1;
					fb[j + 242] = (fb[j + 2] + c2) >> 1;
					j += 3;
				}
			}
		} else {
			final int j = raster * 160 - scx;
			final int n = 160 + scx;
			for (int i = scx; i < n; i++)
			fb[j + i] = palette[linebuf[i]];
		}
	}



	public void setPalette(final int i, final int r, final int g, final int b) {
		palette[i] = ((r << 16) + (g << 8) + b) & 0xFEFEFEFE;
	}

	final PSGi psgi = new PSGi();
	int cursound;

	// TEhftHgl
	private void initSoundSettings() {
		soundVolume_ = 100;
		cursound = 0;
		StereoEnable_[0] = true;
		for(int i=0;i<4;i++) soundChEnable_[i] = true;
		soundBufCount_ = 15;
		soundToneNum_[0] = 80;
		soundToneNum_[1] = 80;
		soundToneNum_[2] = 80;
		soundToneNum_[3] = 80;
		soundToneNum_[4] = 127;
		PCM_SoundBufCount_ = 15;
		for(int i=0;i<4;i++) PCM_soundChannelEnable_[i] = true;
	}
    
	private void setSound() {
		if(cursound <= 3) {
			gbcore.soundMode = 1 ;
		} else {
			gbcore.soundMode = 2 ;
		}
		psgi.setFrameBufCount(soundBufCount_);
		psgi.setSoundStereo(StereoEnable_[0]);
		psgi.setMasterVolume(soundVolume_);
		psgi.setSoundEnable(soundEnable_);
		for(int i=0; i<4 ; i++) 
			psgi.setChEnable(i, soundChEnable_[i]);

		if(cursound == 0) {
			psgi.setMode(PSGi.MODE_PRESET);
			for(int i=0; i<5 ; i++) 
				psgi.setToneBank(i, this.soundToneNum_[i]);
		} else if(cursound == 1) {
			psgi.setMode(PSGi.MODE_YAMAHA);
			for(int i=0; i<5 ; i++) 
				psgi.setToneBank(i, i);
		} else if(cursound == 2) {
			psgi.setMode(PSGi.MODE_ROHM);
			for(int i=0; i<5 ; i++) 
				psgi.setToneBank(i, i);
		} else if(cursound == 3) {
			psgi.setMode(PSGi.MODE_FUETREK);
			for(int i=0; i<5 ; i++) 
				psgi.setToneBank(i, i);
		} else {
			gbcore.pcm.setSoundMode(cursound -4);
		}
		gbcore.pcm.setSoundEnable(soundEnable_);
		gbcore.pcm.setSampleRate(SOUND_RATE_ARRAY[soundSampleRate_]);
		gbcore.pcm.setVolume(soundVolume_);
		gbcore.pcm.setDelay(soundDelay_ +1);
		for(int i=0; i<4 ; i++) gbcore.PCM_soundChannelEnable[i] = PCM_soundChannelEnable_[i];
    }


}